/***************************************************************************
                          audiodeng_buildfilters.cpp  -  description
                             -------------------
    begin                : Mon Dec 2 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>

#include "config.h"
#include "avifmt.h"
#include "avifmt2.h"
#include "avio.hxx"
#include "fourcc.h"
#include "audioprocess.hxx"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_audiofilter/audioeng_buildfilters.h"
#include "ADM_gui/GUI_mp3.h"
#include "ADM_audiofilter/audioeng_ffmp2.h"
#ifdef HAVE_LIBMP3LAME        
	#include "lame/lame.h"
#endif
#include "gui_action.hxx"
/*
  	Ugly should get ride of it. Temporary fix.
*/
#include "avi_vars.h"
extern AUDIOENCODER GUI_getAudioEncoder(void );


#define MAX_AUDIO_FILTER 10
static AVDMProcessAudioStream *filters[MAX_AUDIO_FILTER];
static uint32_t filtercount = 0;

static uint8_t audioNormalizeMode = 0;
static uint8_t audioResampleMode = 0;
static uint8_t audioDRC = 0;


// These are globals for the moment
uint8_t audioShift = 0;
int			audioDelay=0;




// MP3 parameters
static int audioMP3mode = 0, audioMP3bitrate = 128;

//
static AUDIOENCODER  activeAudioEncoder=  AUDIOENC_NONE;

void audioFilter_SetBitrate( int i)
{
	audioMP3bitrate=i;	
}


void audioFilter_NormalizeToggle( void)
{
	audioNormalizeMode^=1;
}
void audioFilter_DRCToggle( void)
{
	audioDRC^=1;
}
void audioFilter_ResampleToggle( void)
{
	 audioResampleMode^=1;
}



void audioFilter_Update( int code)
{
		switch(code)
		{
			case 	 ACT_AudioCodecNone:	activeAudioEncoder=AUDIOENC_NONE;break;
			case 	 ACT_AudioCodecMP2:	activeAudioEncoder=AUDIOENC_MP2;break;
			case 	 ACT_AudioCodecAC3:	activeAudioEncoder=AUDIOENC_AC3;break;
#ifdef HAVE_LIBMP3LAME			
			case 	 ACT_AudioCodecMP3:	activeAudioEncoder=AUDIOENC_MP3;break;
#endif			
			default:assert(0);
						
		}
}
/*
	Refresh   activeAudioEncoder value
	depending on what's selected

*/
	 

/* _____________________________________________________
  		Handle the configure signal from GUI

				pop up GUI 

*/
void audioFilter_Configure( void )
{
	int mode,bitrate;
	bitrate= audioMP3bitrate;
	mode=audioMP3mode;
	switch(activeAudioEncoder)
	{
		case AUDIOENC_NONE:
								return;
#ifdef HAVE_LIBMP3LAME								
		case AUDIOENC_MP3:					 
						
							if (getmp3parameter(&mode, &bitrate,"MP3 parameter"))
								{
									audioMP3mode=mode;
									audioMP3bitrate=bitrate;										
								}
								return;
#endif								
		case AUDIOENC_MP2:
							if (getmp3parameter(&mode, &bitrate,"MP2 parameter"))
								{
									audioMP3mode=mode;
									audioMP3bitrate=bitrate;										
								}
								return;
		case AUDIOENC_AC3:
							if (getmp3parameter(&mode, &bitrate,"AC3 parameter"))
								{
									audioMP3mode=mode;
									audioMP3bitrate=bitrate;										
								}
								return;
		default:
					assert(0);																				
		
	}
	
}
//
// Build audio filters
// Starttime : starttime in ms
// mode : 0 for playback,  1 for audio save
//_______________________________________
AVDMProcessAudioStream *buildAudioFilter(AVDMGenericAudioStream *currentaudiostream,
				uint32_t starttime, uint32_t size, uint8_t mode)
{
	
//
//  Create First filter that is null filter
//
    AVDMProcessAudioStream *firstFilter = NULL;
    AVDMProcessAudioStream *lastFilter = NULL;
    AVDMProcessAudioStream *normalize = NULL;
    AVDMProcessAudioStream *downsample = NULL;
    AVDMProcessAudioStream *tshift = NULL;
    AVDMProcessAudioStream *codec = NULL;
    AVDMProcessAudioStream *drc = NULL;


    printf("\n Audio codec : %d",activeAudioEncoder);
// In fact it is more a decompress filter than a null filter
//

    firstFilter = new AVDMProcessAudio_Null(currentaudiostream,
					    starttime, size);
    filtercount = 0;
    lastFilter = firstFilter;
    filters[filtercount++] = firstFilter;
    // check if we need mono to stereo conversion
    // Petr ..________________________
/*    ____________
    if(lastFilter->getInfo()->channels==1)
    {
      		printf("\n mono->stereo conversion activated.\n");
	    AVDMProcessMono2Stereo *mono;
      				mono=new   AVDMProcessMono2Stereo(lastFilter);
         		  	lastFilter=mono;
                	filters[filtercount++] = lastFilter;
     }
     */
    // /Petr ..____________________________________


    if (!audioProcessMode)
    {


	return lastFilter;

 	}
//_______________________________________________________                                               
    if (audioDelay)
      {
	  if (audioShift)
	    {
		AVDMProcessAudio_TimeShift *ts;
		ts = new AVDMProcessAudio_TimeShift(lastFilter,
						    audioDelay);
		tshift = (AVDMProcessAudioStream *) ts;
		lastFilter = tshift;
		printf("\n Time shift activated with %d ms", audioShift);
		filters[filtercount++] = lastFilter;
	    }
      }


//_______________________________________________________                                               
    if (mode && audioNormalizeMode)	// Normalize activated ?
      {
	  printf("\n  normalize activated...\n");
	  normalize = new AVDMProcessAudio_Normalize(lastFilter);
	  lastFilter = normalize;
	  filters[filtercount++] = lastFilter;
	  // Preprocess input if needed....

	  currentaudiostream->beginDecompress();
	  normalize->preprocess();
	  currentaudiostream->endDecompress();


      }
    if (audioDRC)
      {
	  AVDMProcessAudio_Compress *pdrc = NULL;
	  printf("\n  DRC activated...\n");
	  pdrc = new AVDMProcessAudio_Compress(lastFilter);
	  drc = (AVDMProcessAudioStream *) pdrc;
	  lastFilter = drc;
	  filters[filtercount++] = lastFilter;

      }

//_______________________________________________________                                               

    if (mode && audioResampleMode)
      {
	  if ((lastFilter->getInfo()->frequency != 48000) ||
	      (lastFilter->getInfo()->channels != 2))
	    {
		GUI_Alert
		    (" input is not stereo@48 khz\n Downsample disabled\n");
	  } else
	    {
		printf("\n downsample activated....");
		downsample = new AVDMProcessAudio_Resample(lastFilter, 2);
		lastFilter = downsample;
		filters[filtercount++] = lastFilter;
	    }
      }
//_______________________________________________________                                               
uint8_t init;
		if(mode)
		switch(activeAudioEncoder)
		{
		case 	AUDIOENC_NONE:
						break;
#ifdef HAVE_LIBMP3LAME
		case AUDIOENC_MP3:
        {
	  		AVDMProcessAudio_Lame *plame = NULL;
			  


	 	 // First get parameters from user

	  		plame = new AVDMProcessAudio_Lame(lastFilter);
			  printf("\n Init of lame with bitrate %d , mode %d ",
				 audioMP3bitrate, audioMP3mode);
			  init = plame->initLame(0, (uint32_t) audioMP3mode,
			      (uint32_t) audioMP3bitrate);
			  codec = plame;
			  if (init)
			    {
						lastFilter = codec;
						filters[filtercount++] = lastFilter;
				  } else
			    {
						GUI_Alert("Lame initialization failed\n NOT ACTIVATED");
			    }
			   }
		    break;
#endif
//______________________________________________________
	
		case  AUDIOENC_MP2:
        {
	  		AVDMProcessAudio_FFmp2 *mp2enc = NULL;
			  // First get parameters from user

			  mp2enc = new AVDMProcessAudio_FFmp2(lastFilter);
			  printf("\n Init of FFmpeg with bitrate %d , mode %d ",
				 audioMP3bitrate, audioMP3mode);
			  init = mp2enc->init((uint32_t) audioMP3bitrate);
			  codec = mp2enc;
			  if (init)
			    {
						lastFilter = codec;
						filters[filtercount++] = lastFilter;
				  } else
			    {
					GUI_Alert("FF MP2 initialization failed\n NOT ACTIVATED");
			    }
			    }
    	  break;    
       case  AUDIOENC_AC3:
        {
	  		AVDMProcessAudio_FFAC3 *ac3enc = NULL;
			  // First get parameters from user

			  ac3enc = new AVDMProcessAudio_FFAC3(lastFilter);
			  printf("\n Init of FFmpeg AC3 with bitrate %d , mode %d ",
				 audioMP3bitrate, audioMP3mode);
			  init = ac3enc->init((uint32_t) audioMP3bitrate);
			  codec = ac3enc;
			  if (init)
			    {
						lastFilter = codec;
						filters[filtercount++] = lastFilter;
				  } else
			    {
					GUI_Alert("FF MP2 initialization failed\n NOT ACTIVATED");
			    }
			    }
    	  break;    
      
      default:
      assert(0);
  }
//_______________________________________________________                                               



    currentaudiostream->beginDecompress();
    return lastFilter;
}

// delete audio filters
//______________________
void deleteAudioFilter(void)
{
    for (uint32_t i = 0; i < filtercount; i++)
      {
	  delete filters[i];
	  filters[i] = NULL;
      }
    filtercount = 0;
    if (currentaudiostream)
	currentaudiostream->endDecompress();

}
