/***************************************************************************
                          divx_encode.cpp  -  description
                             -------------------
    begin                : Sun Feb 17 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include "avi_vars.h"
#include "prototype.h"
#ifdef BIG_ENDIAN
#undef BIG_ENDIAN
#endif
//#include "decore.h"
#include "config.h"
#ifdef USE_DIVX
#include "encore2.h"
#include "ADM_colorspace/colorspace.h"
#include "ADM_codecs/ADM_divxEncode.h"

#include "ADM_toolkit/toolkit.hxx"

#define K_ID_ENC this


/*
	allocate and return uncompressed image in buffer

*/
static ENC_PARAM param;
static ENC_FRAME fr;
myENC_RESULT res;

extern int codec_warned;

//
//  Initialize the compressor
//
uint8_t divxEncoderCQ::init(uint32_t q,uint32_t fps1000)
{
    UNUSED_ARG(fps1000);
	if(!codec_warned)
 		{
        	GUI_Alert("\nDivx Codec will create a file\nThis is a bug of linux version\nBe Sure to be on a unix partition\n and have write access");
          codec_warned=1;

     	}
	_q=q;
    printf(" Compressing %lu x %lu video in qz %lu\n", _w, _h, _q);
    assert(0 == _init);
    memset(&param, 0, sizeof(param));
    param.x_dim = _w;
    param.y_dim = _h;
    param.framerate = 25.;
    param.min_quantizer = _q;
    param.max_quantizer = _q;
    param.quality = 5;
    if (ENC_OK != encore(0, ENC_OPT_INIT, &param, 0))
	return 0;
    _handle = param.handle;
    _init = 1;
    return 1;
}

uint8_t divxEncoderCQ::encode(
				uint8_t * in,
			    uint8_t * out,
			    uint32_t * len,
       		uint32_t * flags)
{

    int ret;

    assert(_init);
#ifdef COLORSPACE_YV12
    fr.colorspace = ENC_CSP_YV12;
#else
    fr.colorspace = ENC_CSP_YUY2;
#endif
    fr.quant = _q;
    fr.image = in;
    fr.bitstream = out;
    fr.intra = -1;
    ret = encore(_handle, ENC_OPT_ENCODE, &fr, &res);
    if (res.is_key_frame)
	*flags = AVI_KEY_FRAME;
    else
	*flags = 0;
    *len = (uint32_t) fr.length;
    if (ret == ENC_OK)
			return 1;

    return 0;
}

uint8_t     divxEncoder::stopEncoder(void )
{
    int ret;

    assert(_init);
    ret = encore(_handle, ENC_OPT_RELEASE, 0, 0);
    _init = 0;
    if (ret == ENC_OK)
		return 1;
    return 0;
}
//
//	Return encoding result from the last encoded frame
//
uint8_t divxEncoder::getResult( void *ress)
{
	memcpy(ress,&res,sizeof(res));
   return 1;
}

uint8_t divxEncoder::init( uint32_t val,uint32_t fps1000) {
    UNUSED_ARG(val);
    UNUSED_ARG(fps1000);
	assert(0);
}

uint8_t divxEncoder::encode( uint8_t *in, uint8_t *out, uint32_t *len, uint32_t *flags){
    UNUSED_ARG(in);
    UNUSED_ARG(out);
    UNUSED_ARG(len);
    UNUSED_ARG(flags);
	assert(0);
}
#endif
