/***************************************************************************
                          ADM_edRender.cpp  -  description
                             -------------------
     This file renders the compressed video depending on the availabilty of
     		CODECs.      It also deals with key frame and stuff


    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_codecs/ADM_codec.h"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_filter/video_filters.h"
#include "avi_vars.h"

// FIXME BADLY !!!
static uint8_t compBuffer[MAXIMUM_SIZE*MAXIMUM_SIZE*3];
static uint8_t prepBuffer[MAXIMUM_SIZE*MAXIMUM_SIZE*3];

uint8_t  	ADM_Composer::getRaw(uint32_t framenum,uint8_t *ptr,uint32_t* framelen)
{
uint32_t relframe,seg; //,flags,len;
//uint8_t ret=0;

	   if (!convFrame2Seg(framenum, &seg, &relframe))
      {
	  			printf("\n Conversion failed !\n");
	  			return 0;
	  	}
	  return _segments[seg]._aviheader->getRaw(relframe,ptr,framelen);
}
uint8_t   ADM_Composer::getRawStart(uint32_t frame,uint8_t *ptr,uint32_t *len)
{
	 uint32_t relframe,seg; //,flags;
//uint8_t ret=0;

	   if (!convFrame2Seg(frame, &seg, &relframe))
      {
	  			printf("\n Conversion failed !\n");
	  			return 0;
	  	}
	    return _segments[seg]._aviheader->getRawStart(ptr,len);
	
}
uint8_t ADM_Composer::getUncompressedFrame(uint32_t frame,uint8_t *out,
									uint32_t *flagz)
{
		// first get segment
 	uint32_t relframe,seg,flags,len;
   	uint8_t ret=0;
//    static uint32_t lastlen=0;



   			  // convert frame to block, relative frame
    if (!convFrame2Seg(frame, &seg, &relframe))
      {
	  printf("\n Conversion failed !\n");
	  return 0;
      }
      	uint32_t llen=  _segments[seg]._aviheader->getWidth()
       													*_segments[seg]._aviheader->getHeight();
  					llen=llen+(llen>>1);

    	// cached ?
       //
     if(( _lastseg==seg) &&( _lastframe==relframe)&& ( _cached==1))
     {
       			memcpy(out,prepBuffer,llen);
                 return 1;
      }
      // now we got segment and frame
      // Is is a key frame ?
      _segments[seg]._aviheader->getFlags( relframe, &flags);

      if(flags  & AVI_KEY_FRAME)
      {
         	// yes
      		// Read into ptr
             		
        			if(_segments[seg]._aviheader->needDecompress())
           		{
                	if(! _segments[seg]._aviheader->getFrameNoAlloc(relframe,
                 				compBuffer,
						      	&len,
             					&flags)) return 0;  	
                   		_lastseg		=seg;
                 		 	_lastframe	=relframe;

                  // decode
                  ret=_segments[seg].decoder->uncompress(compBuffer,out,  len,flagz);
                  if((_cached ==1) &&ret)
                  {
                  	 memcpy( prepBuffer,out,llen);
                    }
           		return(ret);	
             }
             else
             {         // does not need decompress (for example mpeg stream)
                	if(! _segments[seg]._aviheader->getFrameNoAlloc(relframe,
                 				out,
						      	&len,
             					&flags))
                  	return 0;  	
                   	_lastseg		=seg;
                 		_lastframe	=relframe;

                  if((_cached ==1))
                  {
                  	 memcpy( prepBuffer,out,llen);
                    }
                    return 1;

               }
        }
         else
        {
           	// following frame ?
            	if((seg==_lastseg) && ((_lastframe+1)==relframe))
             	{
                 	_lastframe++;
                  if(_segments[seg]._aviheader->needDecompress())
                  {
	                  if(! _segments[seg]._aviheader->getFrameNoAlloc(relframe,
                 				compBuffer,
						      	&len,
             					&flags)) return 0;  	

    	              ret=_segments[seg].decoder->uncompress(compBuffer,out,  len,flagz);
                   }
                   else
                   {
                    			ret=_segments[seg]._aviheader->getFrameNoAlloc(relframe,
                 				out,
						      	&len,
             					&flags) ;  	

                     }
                    if((_cached ==1))
                  {
                  	memcpy( prepBuffer,out,llen);

                   }
           		return(ret);	

                }
           }
        // completly async frame
        // rewind
        uint32_t rewind;
        flags=0;

        		rewind= relframe;
          		while(!(flags & AVI_KEY_FRAME))
            	{
               	rewind--;
             		_segments[seg]._aviheader->getFlags(rewind, &flags)  ;
               }
               // now forward
               for(uint32_t i=rewind;i<=relframe;i++)
               {
                  if(! _segments[seg]._aviheader->getFrameNoAlloc(i,
                 				compBuffer,
						      	&len,
             					&flags)) 
                  	{
										printf("\n rewind failed.%ld -> %ld..(%ld)\n",rewind,relframe,i);
										 return 0;  	
						}
					if(	 _segments[seg]._aviheader->needDecompress())
					{
	                  if(!_segments[seg].decoder->uncompress(compBuffer,out,  len	,flagz))
    	              {
       	           		return 0;
           	       }
                 }
                 else
                 {
						memcpy(out,compBuffer,len);				 
					}
                 }
                      if(_cached ==1)
		             		memcpy( prepBuffer,out,llen);
           		
                 _lastseg=seg;
                 _lastframe=relframe;

                 return 1;
}


//
//	Render previous kf
//
uint8_t 		ADM_Composer::getUncompressedFramePKF(uint32_t *frame,
																										uint8_t *out)
{
          uint32_t fr,seg,relframe; //,len; //flags,ret,nf;



          		fr=*frame;

    if(*frame==0)
    {
		return getUncompressedFrame(0,out);
      }


    if(! searchPreviousKeyFrame(fr,&seg,&relframe))
    {
      		printf(" NKF not found\n");
        	return 0;
         }
   			assert(convSeg2Frame(frame,seg,  relframe));
      	
         	return getUncompressedFrame(*frame,out);
}
//
//	Render Next kf
//
uint8_t 		ADM_Composer::getUncompressedFrameNKF(uint32_t *frame,uint8_t *out)
{
          uint32_t fr,seg,relframe,nf; //flags,ret,len;

          		fr=*frame;

    if(! searchNextKeyFrame(fr,&seg,&relframe))
    {
      		printf(" NKF not found\n");
        	return 0;
         }


   			assert(nf=convSeg2Frame(frame,seg,  relframe));
      	
         	return getUncompressedFrame(*frame,out);

}

