/***************************************************************************
                          adm_encConfig.cpp  -  description
                             -------------------
    begin                : Thu Dec 26 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>
#include <config.h>

#include "gui_action.hxx"
#ifdef USE_FFMPEG
#include "ADM_lavcodec.h"  
#endif

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"

#include "ADM_encoder/ADM_vidEncode.hxx"

#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_encoder/adm_encoder.h"
#include "prefs.h"
#ifdef USE_DIVX
#include "ADM_codecs/ADM_divxEncode.h"
#include "ADM_encoder/adm_encdivx.h"
 
  
#endif

extern void GUI_setVideoCodec(Action action );

extern int getCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fs);

#ifdef USE_XX_XVID
	#include "ADM_codecs/ADM_xvid.h"
	#include "ADM_encoder/adm_encxvid.h"
	#include "xvid.h"
  extern uint8_t xvid_loaded;
  extern int getXvidCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,xvidEncParam *param);
#endif

#ifdef USE_MJPEG
    #include "ADM_codecs/ADM_mjpegEncode.h"
	#include "ADM_encoder/adm_encmjpeg.h"
#endif

#ifdef USE_FFMPEG
  #include "ADM_codecs/ADM_ffmpeg.h"
	#include "ADM_encoder/adm_encffmpeg.h"
	
extern int getFFCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf);
	
	
#endif

/*
  	Codec settings here

*/
#ifdef USE_FFMPEG
  FFMPEGConfig ffmpegConfig={
  	{COMPRESS_CQ,4,1500,700},
	{
	 ME_EPZS,//	ME
	 0, // 		GMC	
	 1,//		_4MV;
	 0,//		_QPEL;
	 1,//		_HQ;
	 0,//		_TREILLIS_QUANT
	 2,//		qmin;
	 31,//		qmax;
	 3,//		max_qdiff;
	 0,//		max_b_frames;
	 0, //		mpeg_quant;
	 -2, // 		luma_elim_threshold;
	 -5, // 		chroma_elim_threshold;	
	 0.05,//		lumi_masking;
	 0.01,//		dark_masking; 
 	 0.5,// 	qcompress;  /* amount of qscale change between easy & hard scenes (0.0-1.0)*/
    	 0.5,// 	qblur;      /* amount of qscale smoothing over time (0.0-1.0) */

 	} 
  };
  
  // mpeg1
  
 FFMPEGConfig ffmpegMpeg1Config={
  	{COMPRESS_CBR,4,1500,700},
	{
	 ME_EPZS,//	ME
	 0, // 		GMC	
	 0,//		_4MV;
	 0,//		_QPEL;
	 1,//		_HQ;   =1 means no B frame
	 0,//		_TREILLIS_QUANT
	 2,//		qmin;
	 31,//		qmax;
	 3,//		max_qdiff;
	 0,//		max_b_frames;
	 1, //		mpeg_quant;
	 -2, // 		luma_elim_threshold;
	 -5, // 		chroma_elim_threshold;	
	 0.05,//		lumi_masking;
	 0.01,//		dark_masking; 
 	 0.5,// 	qcompress;  /* amount of qscale change between easy & hard scenes (0.0-1.0)*/
    	 0.5,// 	qblur;      /* amount of qscale smoothing over time (0.0-1.0) */

 	} 
  };  
  
  
#endif
/*

*/
#ifdef USE_XX_XVID
 static XVIDconfig  xvidConfig={{COMPRESS_CQ,4,1500,700},
                    {
												 
	 0, // interlaced;
	 1, // inter4v;
	 XVID_H263QUANT,// quantizer;       
	 2,// imin;
	 31, // imax;
	 2 ,// pmin;
	 31, // pmax;
	 
	 0,// lumi;
	 
 	 XVID_ME_PMVFAST, // me;
	 1,// halfpel  ;

	 
	 10, // kfboost;
	 6, // min_key_interval;
	 0, // max_key_interval;
	 
	 	25, // curve_compression_high;
		10, // curve_compression_low;

		240, // 	bitrate_payback_delay;
	 
	
	 
	 0,// startcred_start;
	 0,// startcred_end;
	

	 0,// endcred_start;
	 0,// endcred_end;
	 
	 0,// cred_rate;
	 
	
	1, // use_alt_curve;
	2, //VBR_ALT_CURVE_LINEAR, //int alt_curve_type;
	90, // alt_curve_low_dist;
	500, // alt_curve_high_dist;
	50, // alt_curve_min_rel_qual;
	1, // alt_curve_use_auto;
	1, // alt_curve_auto_str;
	1, // alt_curve_use_auto_bonus_bias;
	50, // alt_curve_bonus_bias;
	1//VBR_PAYBACK_BIAS // bitrate_payback_method 	 ;
//	"/tmp/Xvid2passLog.txt"; // path

										}
 										};;

#endif
#ifdef USE_DIVX
 static DIVXConfig  divxConfig={{COMPRESS_CQ,4,1500,700}};
 																
#endif 
char TwoPassLogFile[300]; 
void saveEncoderConfig( void );


///////////////////////////////////////////
extern SelectCodecType current_codec;

void encoderSetLogFile(char *name)
{
		strcpy( TwoPassLogFile,name);
		printf("\n Log file is now :%s\n",TwoPassLogFile);
}
//___________________________________________________
typedef struct codecEnumByName
{
	SelectCodecType type;
	const char	*name;
	Action           action;
}codecEnumByName;

static const codecEnumByName mycodec[]=
{
#ifdef USE_DIVX
	{CodecDivx	,"Divx",ACT_SelectCodecDivx},
#endif
#ifdef USE_XVID	
	{CodecXvid	,"Xvid",ACT_SelectCodecXvid},
#endif	
	
#ifdef USE_MJPEG	
	{CodecMjpeg	,"Mjpeg",ACT_SelectCodecMjpeg},
#endif	
	{CodecFF	,"FFmpeg4",ACT_SelectCodecFF},
	{CodecH263	,"H263",ACT_SelectCodecFFH263,},
	{CodecH263P	,"H263+",ACT_SelectCodecFFH263P},
	{CodecHuff	,"Huffyuv",ACT_SelectCodecHuff}
};
//___________________________________________________
void saveEncoderConfig( void )
{
	for(uint32_t i=0;i<sizeof(mycodec)/sizeof(codecEnumByName);i++)
	{
		if(current_codec==mycodec[i].type)
		{
			prefs->set(CODECS_PREFERREDCODEC,mycodec[i].name);
		}
	
	}
	
}
void loadEncoderConfig ( void )
{
const char *name;
		if(!prefs->get(CODECS_PREFERREDCODEC, &name))
		{
			printf("could not get prefered codec!\n");
			return;
		}
		for(uint32_t i=0;i<sizeof(mycodec)/sizeof(codecEnumByName);i++)
		{
			if(!strcmp(name,mycodec[i].name))
			{
				// we change codec	through the gui			
				GUI_setVideoCodec(mycodec[i].action);
				return;
			}
	
		}


}

void initEncoders( void)
{
		strcpy( TwoPassLogFile,"/tmp/Xvid2passLog");
}
//
// configure the video codec
//
//______________________________
void videoCodecConfigure( void )
{
	printf("\n configuring codec :%d\n",current_codec);
	switch(current_codec)
			{				
				
#ifdef USE_XX_XVID
      	 	case CodecXvid :   								  
			 		getXvidCompressParams(&xvidConfig.generic.mode,
							&xvidConfig.generic.qz,
		      					&xvidConfig.generic.bitrate,
		        				&xvidConfig.generic.finalsize,
		                      			&xvidConfig.specific);		
		      			break;
#endif								
#ifdef  USE_MJPEG
					case CodecMjpeg : 
						break;
#endif	
#ifdef USE_DIVX
					
		case CodecDivx :   
			  		getCompressParams(&divxConfig.generic.mode,
							&divxConfig.generic.qz,
							&divxConfig.generic.bitrate,
							&divxConfig.generic.finalsize);
		    			break;
#endif		
#ifdef USE_FFMPEG	
		case CodecHuff:
				break;	
		case  CodecH263P:  
					printf("\n H263P\n");					
		case  CodecH263:  
					printf("\n H263\n");					
		case  CodecFF: 
/*
					getCompressParams(&ffmpegConfig.generic.mode,
							&ffmpegConfig.generic.qz,
							&ffmpegConfig.generic.bitrate,
							&ffmpegConfig.generic.finalsize);	
*/
					getFFCompressParams(&ffmpegConfig.generic.mode,
							&ffmpegConfig.generic.qz,
							&ffmpegConfig.generic.bitrate,
							&ffmpegConfig.generic.finalsize,
							&ffmpegConfig.specific);
							
					break;
#endif
					default:
								assert(0);
					}								  			
	
	
}
//___________________________________________________________

void setVideoEncoderSettings(COMPRESSION_MODE mode, int param)
{
	COMPRES_PARAMS *generic = NULL;
	switch( current_codec)
	{
#ifdef USE_XX_XVID
      	 	case CodecXvid :   								  
				  		generic=&xvidConfig.generic;		
		      		break;
#endif								
#ifdef  USE_MJPEG
					case CodecMjpeg : 
						break;
#endif	
#ifdef USE_DIVX
					
				 	case CodecDivx :   
				  			generic=&divxConfig.generic;		
		    			break;
#endif		
#ifdef USE_FFMPEG		  
					case  CodecFF:
					case  CodecH263:
					case  CodecH263P:
					case  CodecHuff:
					 
											generic=&ffmpegConfig.generic ;
											break;
#endif
					default:
								assert(0);
				
	}
	  generic->mode=mode;
	  switch(mode)
	  {
				case COMPRESS_CBR:
								generic->bitrate=param;
								break;
				case COMPRESS_CQ:
								generic->qz=param;
								break;
				case COMPRESS_2PASS:
								generic->finalsize=param;
								break;
				default:
								assert(0);												
															
		}
	
}
Encoder *getVideoEncoder( uint32_t w,uint32_t h )

{

//int s;
Encoder *e=NULL;

		switch(current_codec)
			{
#ifdef USE_FFMPEG
#ifndef USE_DIVX
					default:				  
#endif
      	 	case CodecFF :   								  
				  		e=new   EncoderFFMPEG(FF_MPEG4,&ffmpegConfig);
				    	break;			
#endif		

#ifdef USE_FFMPEG
		case   CodecHuff:
					e=new   EncoderFFMPEGHuff(&ffmpegConfig);
				    	break;		
		case   CodecH263P:
					e=new   EncoderFFMPEG(FF_H263P,&ffmpegConfig);
				    	break;		
      	 	case CodecH263 : 
         			if( !((w==128) && (h=96)) &&
            		! ((w==176) && (h=144))) 
              	{
								  	GUI_Alert("Only Qcif and SubQcif allowed \n for H263 codec");
								    return 0;
								 } 								  
				  		e=new   EncoderFFMPEG(FF_H263,&ffmpegConfig);
				    	break;			
#endif										
				
#ifdef USE_XX_XVID
      	 	case CodecXvid :   								  
				  		e=new   EncoderXvid( &xvidConfig); 
				    	break;			
#endif								
#ifdef  USE_MJPEG
					case CodecMjpeg : 
							e=new   EncoderMjpeg(); break;
#endif	
#ifdef USE_DIVX
					default:				  
				 	case CodecDivx :   
				  		e=new   EncoderDivx(&divxConfig); break;
#endif				    
				  			
			
				}
         if(!e) 
#ifdef USE_DIVX         	
          e=new   EncoderDivx(&divxConfig);
#else
					e=new   EncoderFFMPEG(FF_MPEG4,&ffmpegConfig);
#endif          
		return e;
	
}

