/***************************************************************************
                          filter_declaration.cpp  -  description

                          Declare filters, should be automatic but it does not work
                          Have to fix that later on
                             -------------------
    begin                : Fri Mar 29 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <assert.h>


#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER

#include "ADM_toolkit/toolkit.hxx"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_filter/video_filters.h"
//
static  AVDMGenericVideoStream *res_create(AVDMGenericVideoStream *in, void *param);
static  AVDMGenericVideoStream *crop_create(AVDMGenericVideoStream *in, void *param);
static  AVDMGenericVideoStream *bsmear_create(AVDMGenericVideoStream *in, void *param);
extern   AVDMGenericVideoStream *sharpen_create(AVDMGenericVideoStream *in, void *param);
extern   AVDMGenericVideoStream *addBorder_create(AVDMGenericVideoStream *in, void *param);
extern  AVDMGenericVideoStream *luma_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *telecide_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *stabilize_create(AVDMGenericVideoStream *in, void *param);
extern  AVDMGenericVideoStream *flipv_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *fluxsmooth_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *vladsmooth_create(AVDMGenericVideoStream *in, void *param);

//
// Resize
extern     AVDMGenericVideoStream *mean_create(AVDMGenericVideoStream *in, void *param);
extern     AVDMGenericVideoStream *median_create(AVDMGenericVideoStream *in, void *param);
extern 	 AVDMGenericVideoStream *Gaussian_create(AVDMGenericVideoStream *in, void *param);
extern 	 AVDMGenericVideoStream *smooth_create(AVDMGenericVideoStream *in, void *param);
extern 	 AVDMGenericVideoStream *deinterlace_create(AVDMGenericVideoStream *in, void *param);
extern     AVDMGenericVideoStream *tempsmooth_create(AVDMGenericVideoStream *in, void *param);
extern 	AVDMGenericVideoStream *addPALShift_create(AVDMGenericVideoStream *in, void *param) ;
extern 	AVDMGenericVideoStream *chromaU_create(AVDMGenericVideoStream *in, void *param);
extern 	AVDMGenericVideoStream *chromaV_create(AVDMGenericVideoStream *in, void *param);
extern 	AVDMGenericVideoStream *swapuv_create(AVDMGenericVideoStream *in, void *param);
extern 	AVDMGenericVideoStream *contrast_create(AVDMGenericVideoStream *in, void *param);
extern 	AVDMGenericVideoStream *denoise_create(AVDMGenericVideoStream *in, void *param);
#ifdef USE_FREETYPE
extern  AVDMGenericVideoStream *subtitle_create(AVDMGenericVideoStream *in, void *param);
#endif
extern AVDMGenericVideoStream *salt_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *largeMedian_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *partial_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *rotate_create(AVDMGenericVideoStream *in, void *param);
extern AVDMGenericVideoStream *dropout_create(AVDMGenericVideoStream *in, void *param);

void registerVideoFilters( void )
{
printf("\n Registering Filters\n");
printf(  "*********************\n");

	registerFilter("---- Image size/border alteration----",VF_INVALID,2,crop_create);
	registerFilter("Crop",VF_CROP,1,crop_create);
	registerFilter("Resize",VF_RESIZE,1,res_create);
    	registerFilter("Blacken Borders",VF_BLACKEN,1,bsmear_create);	
  	registerFilter("Add black border",VF_ADDBORDER,1,addBorder_create);    	
  	registerFilter("Flip Vertical",VF_FLIP,1,flipv_create);	
	registerFilter("Rotate",VF_ROTATE,1,rotate_create);	
	registerFilter("----------- Interlacing -------------",VF_INVALID,2,crop_create);   
	registerFilter("PAL-SMART",VF_TELECIDE,1,telecide_create);
	registerFilter("Deinterlace",VF_DEINTERLACE,1,deinterlace_create);
   	registerFilter("Pal Field shift",VF_PALSHIFT,1,addPALShift_create);
	
        registerFilter("Drop",VF_DROPOUT,1,dropout_create);
	               
    
 	
	registerFilter("Partial",VF_PARTIAL,0,partial_create);    		
	registerFilter("-------- Convolution Kernel ---------",VF_INVALID,2,crop_create);   		
	registerFilter("Sharpen",VF_SHARPEN,1,sharpen_create);
   	registerFilter("Mean",VF_MEAN,1,mean_create);
   	registerFilter("Median",VF_MEDIAN,1,median_create);
	registerFilter("Median (5x5)",VF_LARGEMEDIAN,1,largeMedian_create);     
    	registerFilter("Gauss Smooth",VF_GAUSSIAN,1,Gaussian_create);
       	
    //   registerFilter("Temporal smoother",tempsmooth_create);
	registerFilter("------------ Luma/Chroma ------------",VF_INVALID,2,crop_create);   
	      
 	registerFilter("Swap u & v",VF_SWAPUV,1,swapuv_create);
	registerFilter("Contrast",VF_CONTRAST,1,contrast_create);

	registerFilter("Luma only",VF_LUMA,1,luma_create);
	registerFilter("Chroma U only",VF_CHROMAU,1,chromaU_create);
	registerFilter("Chroma V only",VF_CHROMAV,1,chromaV_create);
		
	registerFilter("-------------- Smoother -------------",VF_INVALID,2,crop_create);   
		
	registerFilter("Stabilize",VF_STABILIZE,1,stabilize_create);
 	registerFilter("Denoise",VF_DENOISE,1,denoise_create);
	registerFilter("FluxSmooth",VF_FLUXSMOOTH,1,fluxsmooth_create);
    	registerFilter("Smooth Clean",VF_SMOOTHCLEAN,0,smooth_create); 
    	registerFilter("Temporal Cleaner",VF_VLADSMOOTH,1,vladsmooth_create); 		    
#ifdef USE_FREETYPE   
	registerFilter("----------------- Misc --------------",VF_INVALID,2,crop_create);      
	registerFilter("Subtitler",VF_SUBTILE,1,subtitle_create);
#endif			
			

	registerFilter("Remove Salt",VF_SALT,0,salt_create);
 printf("\n");
}		


//
AVDMGenericVideoStream *res_create(AVDMGenericVideoStream *in, void *param)
{
 	return new   AVDMVideoStreamResize(in,param);
}

AVDMGenericVideoStream *crop_create(AVDMGenericVideoStream *in, void *param)
{
 	return new   AVDMVideoStreamCrop(in,param);
}; ;
AVDMGenericVideoStream *bsmear_create(AVDMGenericVideoStream *in, void *param)
{
 	return new   AVDMVideoStreamBSMear(in,param);
}; ;

#endif
