/***************************************************************************
                          GUI_About.cpp  -  description
                             -------------------
    begin                : Sat Apr 13 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "avi_vars.h"
#include "xpm/about.xpm"

extern GtkWidget *GUI_PixmapButtonDefault(GdkWindow * window, const gchar ** xpm,
					  const gchar * tooltip);
extern GtkWidget *GUI_PixmapButton(GdkWindow * window, const gchar ** xpm,
				   const gchar * tooltip, gint border);



 //___________________________________________________
//___________________________________________________
//___________________________________________________

GtkWidget *create_aboutwindow(GtkWidget * parent)
{
    GtkWidget *aboutwindow;
    GtkWidget *about_button;

    aboutwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_realize(aboutwindow);
    gtk_object_set_data(GTK_OBJECT(aboutwindow), "aboutwindow",
			aboutwindow);
    gtk_window_set_title(GTK_WINDOW(aboutwindow), "window2");
    gtk_window_set_position(GTK_WINDOW(aboutwindow), GTK_WIN_POS_CENTER);
    gtk_window_set_modal(GTK_WINDOW(aboutwindow), TRUE);
    gdk_window_set_decorations(aboutwindow->window,
			       (GdkWMDecoration) ! GDK_DECOR_ALL);
    gtk_window_set_transient_for(GTK_WINDOW(aboutwindow),
				 GTK_WINDOW(parent));

    about_button =
	GUI_PixmapButton(aboutwindow->window, xpm_about, NULL, 0);
    gtk_button_set_relief(GTK_BUTTON(about_button), GTK_RELIEF_NONE);
    gtk_widget_show(about_button);
    gtk_container_set_border_width(GTK_CONTAINER(aboutwindow), 0);
    gtk_container_add(GTK_CONTAINER(aboutwindow), about_button);
    gtk_signal_connect(GTK_OBJECT(about_button), "clicked",
		       GTK_SIGNAL_FUNC(on_about_button_clicked), NULL);
    gtk_widget_realize(about_button);
    gtk_widget_grab_focus(about_button);
    gtk_window_activate_focus(GTK_WINDOW(aboutwindow));
    gtk_window_activate_default(GTK_WINDOW(aboutwindow));

    return aboutwindow;
}
