/***************************************************************************
                          GUI_MPPP.cpp  -  description
                             -------------------
    begin                : Fri Jan 17 2003
    copyright            : (C) 2003 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "math.h"
#include "ADM_gui/GUI_MPP.h"
#include "ADM_library/default.h"
static GtkWidget	*create_dialog1 (int sc);

static  GtkWidget *checkbutton_hv;
static  GtkWidget *checkbutton_vd;
static  GtkWidget *checkbutton_dr; 
static  GtkWidget *hscale_strength;
static  GtkObject *pp_adj;
static void on_callback_destory(GtkButton * button, gpointer user_data);
static void on_sel_ok(GtkButton * button, gpointer user_data)          ;
static int lock;
extern void runDialog(volatile int *a);
//-----------------------------------------------

int getMPParams( int *pplevel, int *ppstrength)
 {
    GtkWidget *wdg;
    int ret=0;

    wdg = create_dialog1(*ppstrength);
    lock = 0;
    
#define SET_TOG(x,y) { if(*pplevel & x)  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(y),1);    else \
                                     gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(y),0); }
    
    		SET_TOG(1, checkbutton_hv);
    		SET_TOG(2, checkbutton_vd);
     		SET_TOG(4, checkbutton_dr);
         gtk_widget_show(wdg);
#undef SET_TOG
  
    runDialog(&lock);
    if (lock == 1)    // OK
      {	

           *ppstrength=   (int)floor(GTK_ADJUSTMENT(pp_adj)->value);
#define GET_TOG(x,y) { if( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(y)))   \
                                *pplevel+=x;     }
        *pplevel=0;
    		GET_TOG(1, checkbutton_hv);
    		GET_TOG(2, checkbutton_vd);
     		GET_TOG(4, checkbutton_dr);
#undef GET_TOG             		
     		
			 ret=1;
      }
      if(lock!=-2)     gtk_widget_destroy(wdg);
    return ret;

}



//---------------------------------------------
void on_callback_destory(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    on_sel_ok(NULL, (gpointer) -1);
}

void on_sel_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (lock)
			return;			// second call back->ignore.
    switch (res)
      {
      case 1:
				  lock = 1;
				  break;
      case 0:
	  			lock = -1;
	     		break;
      case -1:
	  			lock = -2;
				  break;
      }
    return;

};


GtkWidget	*create_dialog1 (int scale)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *vbox3;
//  GtkWidget *checkbutton_hv;
//  GtkWidget *checkbutton_vd;
//  GtkWidget *checkbutton_dr;
  GtkWidget *vbox2;
  GtkWidget *label1;
//  GtkWidget *hscale_strength;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button_ok;
  GtkWidget *button_ko;

  dialog1 = gtk_dialog_new ();
//  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_object_set_data_full(GTK_OBJECT(dialog1),
			     "dialog1",
			     dialog1,
			     (GtkDestroyNotify) on_callback_destory);
  gtk_window_set_title (GTK_WINDOW (dialog1), (" MPlayer PostProcessing"));
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);
 gtk_window_set_modal(GTK_WINDOW(dialog1), 1);
  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);
  gtk_widget_set_usize (dialog_vbox1, 148, 148);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), vbox3, TRUE, TRUE, 0);

  checkbutton_hv = gtk_check_button_new_with_label (("Horizontal Deblocking"));
  gtk_widget_ref (checkbutton_hv);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "checkbutton_hv", checkbutton_hv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_hv);
  gtk_box_pack_start (GTK_BOX (vbox3), checkbutton_hv, FALSE, FALSE, 0);

  checkbutton_vd = gtk_check_button_new_with_label (("Vertical Deblocking"));
  gtk_widget_ref (checkbutton_vd);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "checkbutton_vd", checkbutton_vd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_vd);
  gtk_box_pack_start (GTK_BOX (vbox3), checkbutton_vd, FALSE, FALSE, 0);

  checkbutton_dr = gtk_check_button_new_with_label (("Deringing"));
  gtk_widget_ref (checkbutton_dr);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "checkbutton_dr", checkbutton_dr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_dr);
  gtk_box_pack_start (GTK_BOX (vbox3), checkbutton_dr, FALSE, FALSE, 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), vbox2, TRUE, TRUE, 0);

  label1 = gtk_label_new (("Filter Strength"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox2), label1, FALSE, FALSE, 0);

  
  pp_adj=gtk_adjustment_new (scale, 1, 5, 1, 1, 0); //gtk_adjustment_new (2, 2, 10, 1, 1, 1);

  hscale_strength = gtk_hscale_new (GTK_ADJUSTMENT(pp_adj));
  gtk_widget_ref (hscale_strength);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hscale_strength", hscale_strength,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hscale_strength);
  gtk_box_pack_start (GTK_BOX (vbox2), hscale_strength, TRUE, TRUE, 0);
  gtk_scale_set_digits (GTK_SCALE (hscale_strength), 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label (("Ok"));
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ok, FALSE, FALSE, 0);

  button_ko = gtk_button_new_with_label (("Cancel"));
  gtk_widget_ref (button_ko);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ko", button_ko,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ko);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ko, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
		      GTK_SIGNAL_FUNC (on_sel_ok), (void *) 1);
  gtk_signal_connect (GTK_OBJECT (button_ko), "clicked",
		      GTK_SIGNAL_FUNC (on_sel_ok), (void *) 0);

  
  return dialog1;
}

