/***************************************************************************
                          GUI_XvidEncoder.cpp  -  description
                             -------------------
    begin                : Fri Jul 19 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr


	Flag1:       Motion estimation : Goes to ENC_FRAME.general
					

	Flag2:     XVID_ENC_FRAME.motion



	Flag3:     XVID_ENC_PARAM.global

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#  include <config.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <config.h>
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <assert.h>
#include <math.h>


#include "ADM_library/default.h"
#include "ADM_encoder/ADM_vidEncode.hxx"
#include "ADM_gui/GUI_xvidparam.h"
#include "ADM_toolkit/filesel.h"
#include "ADM_toolkit/toolkit.hxx"

#ifdef USE_XX_XVID
#include "xvid.h"


extern uint8_t getRangeInMenu(GtkWidget *w);

static void gui_ok(GtkButton * button, gpointer user_data);
//static void gui_del(GtkButton * button, gpointer user_data);

static GtkWidget *create_xvidCompression (void);

static int compresslock;
static void update( void);
//------------------------------------------
static GtkWidget *radiobutton1;
static GtkWidget *radiobutton2;
static GtkWidget *radiobutton3;
static 		GtkWidget *entry_qz;
static 		GtkWidget *entry_bitrate;
static 		GtkWidget *entry_size;
static  	GtkWidget *optionmenu_quant;
static  	GtkWidget *optionmenu_quant_menu;
static 		GtkWidget *optionmenuME;
static 		GtkWidget *optionmenuME_menu;
static   	GtkWidget * togglebutton_interlaced;;
static 		GtkWidget *togglebutton_inter4v;
static   	GtkWidget *  togglebutton_halfpel ;
static   	GtkWidget *  togglebutton_lumi ;

static GtkWidget    *spinbutton_kfboost;
static GtkWidget    *spinbutton_imin;
static GtkWidget    *spinbutton_imax;
static GtkWidget    *spinbutton_pmin;
static GtkWidget    *spinbutton_pmax;

static  GtkWidget *spinbutton_startstart;
static  GtkWidget *spinbutton_startend;

static  GtkWidget *spinbutton_cred_rate;

static  GtkWidget *spinbutton_endstart;
static  GtkWidget *spinbutton_endend;

static  GtkWidget *spinbutton_iframeintervall;
static  GtkWidget *spinbutton_hiscene;
static  GtkWidget *spinbutton_lowscene;
static  GtkWidget *spinbutton_payback;

static GtkWidget *radiobutton_biaspayback;
static GtkWidget *radiobutton_proppayback;

static GtkWidget *togglebutton_usealt;
static GtkWidget *spinbutton_alt_curve_high_dist;
static GtkWidget *spinbutton_alt_curve_low_dist;
static GtkWidget *spinbutton_strength;
static GtkWidget *optionmenu_curve;
static GtkWidget *optionmenu_curve_menu;


static xvidEncParam *myParam;
  
//-------------------------------------------------
static void gui_load(GtkButton * button, gpointer user_data);
static void gui_save(GtkButton * button, gpointer user_data) ;
static void cb_load(char *name);
static void cb_save(char *name);
static void read( void );

int getXvidCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,xvidEncParam *param);

static 					uint32_t  stQuant[2]={XVID_MPEGQUANT,XVID_H263QUANT};
static 					uint32_t  stME[7]={
				 XVID_ME_ZERO,
				 XVID_ME_LOGARITHMIC,
				 XVID_ME_FULLSEARCH   ,
				 XVID_ME_PMVFAST         ,
				 XVID_ME_EPZS                   };
				 
static uint32_t stCurving[3]={
	
				1,
				2,
				3					 
					      
					           };				 
#warning Alt HARCODED					           

/*				 
void gui_del(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    gui_ok(NULL, (gpointer) -1);
}
*/

void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    int res;

    res = (int) user_data;
    if (compresslock)
	return;			// second call back->ignore.
    switch (res)
      {
      case 1:
	  compresslock = 1;
	  //gtk_hide_widget(wdg);

	  break;
      case 0:
	  compresslock = -1;
	  break;
      case -1:
     	compresslock=-2;
      	break;
       default:
       		assert(0);
      }
    return;

};

void read( void )
{
						myParam->quantizer= stQuant[getRangeInMenu(optionmenu_quant)];
						myParam->me				= stME[getRangeInMenu(optionmenuME)];
      			myParam->alt_curve_type				= stCurving[getRangeInMenu(optionmenu_curve)];
         
	          if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radiobutton_biaspayback)))
	          {
							myParam->bitrate_payback_method =1;
						}
						else
						{
							myParam->bitrate_payback_method=2;
						}
         
	#define CHECKBOX(x,y) if(TRUE==gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x)))  \
																myParam->y=1; else myParam->y=0;
					// check extra button : halpel & 4v
          			CHECKBOX( togglebutton_inter4v,inter4v);
          			CHECKBOX( togglebutton_halfpel,halfpel);
					      CHECKBOX( togglebutton_interlaced,interlaced);
					      CHECKBOX( togglebutton_lumi,lumi);
					      printf("\n Alt ?\n");
                CHECKBOX( togglebutton_usealt,use_alt_curve);

						#undef CHECKBOX
						
						#define CHECKSPIN(x,y) myParam->y= gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(x)) ;
          			CHECKSPIN( spinbutton_imin,imin);
          			CHECKSPIN( spinbutton_imax,imax);
          			CHECKSPIN( spinbutton_pmin,pmin);
          			CHECKSPIN( spinbutton_pmax,pmax);						

 								CHECKSPIN(spinbutton_cred_rate,cred_rate);
												
								CHECKSPIN(spinbutton_startstart,startcred_start);
								CHECKSPIN(spinbutton_startend,startcred_end);

								CHECKSPIN(spinbutton_endstart,endcred_start);
								CHECKSPIN(spinbutton_endend,endcred_end);
							
				        // 2 pass
								CHECKSPIN(spinbutton_iframeintervall,min_key_interval);		
								CHECKSPIN(spinbutton_hiscene,curve_compression_high);		
								CHECKSPIN(spinbutton_lowscene,curve_compression_low);		
								CHECKSPIN(spinbutton_payback,bitrate_payback_delay);				
				   			CHECKSPIN( spinbutton_kfboost,kfboost);
				      
			          CHECKSPIN( spinbutton_alt_curve_low_dist,alt_curve_low_dist);
 						    CHECKSPIN( spinbutton_alt_curve_high_dist,alt_curve_high_dist);
           	    CHECKSPIN( spinbutton_strength,alt_curve_auto_str);
						                  						                  
						#undef CHECKSPIN	
	
}
void update( void)
{

 if( myParam->bitrate_payback_method ==1)
 		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton_biaspayback),1);
 else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton_proppayback),1);
   

		#define CHECKBOX(x,y) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x),myParam->y) 
					// check extra button : halpel & 4v
          			CHECKBOX( togglebutton_inter4v,inter4v);
          			CHECKBOX( togglebutton_halfpel,halfpel);
					      CHECKBOX( togglebutton_interlaced,interlaced);
					      CHECKBOX( togglebutton_lumi,lumi);
           			CHECKBOX( togglebutton_usealt,use_alt_curve);

						#undef CHECKBOX

						
						#define CHECKSPIN(x,y)  gtk_spin_button_set_value(GTK_SPIN_BUTTON(x),(gfloat)myParam->y) ;
          			CHECKSPIN( spinbutton_imin,imin);
          			CHECKSPIN( spinbutton_imax,imax);
          			CHECKSPIN( spinbutton_pmin,pmin);
          			CHECKSPIN( spinbutton_pmax,pmax);						
						
								CHECKSPIN(spinbutton_startstart,startcred_start);
								CHECKSPIN(spinbutton_startend,startcred_end);
								
								CHECKSPIN(spinbutton_cred_rate,cred_rate);

								CHECKSPIN(spinbutton_endstart,endcred_start);
								CHECKSPIN(spinbutton_endend,endcred_end);
								
				        // 2 pass
								CHECKSPIN(spinbutton_iframeintervall,min_key_interval);		
								CHECKSPIN(spinbutton_hiscene,curve_compression_high);		
								CHECKSPIN(spinbutton_lowscene,curve_compression_low);		
								CHECKSPIN(spinbutton_payback,bitrate_payback_delay);				
				   			CHECKSPIN( spinbutton_kfboost,kfboost);
				      
                CHECKSPIN( spinbutton_alt_curve_low_dist,alt_curve_low_dist);
 						    CHECKSPIN( spinbutton_alt_curve_high_dist,alt_curve_high_dist);
           	    CHECKSPIN( spinbutton_strength,alt_curve_auto_str);
                                                  						                  						                  
						#undef CHECKSPIN				     	
	
}

void gui_load(GtkButton * button, gpointer user_data)
{
        UNUSED_ARG(button);
    	UNUSED_ARG(user_data);
        printf(" Loading Xvid settings..\n");
	    GUI_FileSelRead("Xvid conf to read",cb_load);
	
}

void gui_save(GtkButton * button, gpointer user_data)
{
        UNUSED_ARG(button);
    	UNUSED_ARG(user_data);
        printf(" Saving Xvid settings..\n");
	    GUI_FileSelWrite("Xvid conf to save",cb_save);
	
}
void cb_save(char *name)
{
	FILE *fd;
	
		read();
		fd=fopen(name,"wb");
		if(!fd)
		{
				GUI_Alert("Cannot save conf!");
				return;			
		}
		fwrite(myParam,sizeof(*myParam),1,fd);
		fclose(fd);
	
	
}
void cb_load(char *name)
{
	FILE *fd;
	
		fd=fopen(name,"rb");
		if(!fd)
		{
				GUI_Alert("Cannot load conf!");
				return;			
		}
		fread(myParam,sizeof(*myParam),1,fd);
		fclose(fd);
	  update();
	
}


int getXvidCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,xvidEncParam *param)
{
    static GtkWidget *cprm;
    char *str;
    char string[100];
    uint32_t value;
    int ret = 0;

	myParam=param;
/*	*br=1000;
	*qz=4;
	*mode=COMPRESS_CQ;*/
//	memset(param,0,sizeof(xvidEncParam));

    do
      {
	  compresslock = 0;
	  cprm = create_xvidCompression();
	  //
	  switch (*mode)
	    {
	    case COMPRESS_CBR:
	
		    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
						 (radiobutton2), 1);

		sprintf(string, "%d", (int) *br / 1000);
		   gtk_editable_delete_text(GTK_EDITABLE(entry_bitrate),
					 0, -1);
		gtk_editable_insert_text(GTK_EDITABLE(entry_bitrate),
					 string, strlen(string), &ret);
		break;

		   case COMPRESS_2PASS:
		    		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
						 	(radiobutton3), 1);

					sprintf(string, "%d", (int) *fsize );
					 gtk_editable_delete_text(GTK_EDITABLE(entry_size),
					 0, -1);
					gtk_editable_insert_text(GTK_EDITABLE(entry_size),
					 string, strlen(string), &ret);

		break;

	    case COMPRESS_CQ:
					gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
					     (radiobutton1), 1);

					sprintf(string, "%d", (int) *qz);
					 gtk_editable_delete_text(GTK_EDITABLE(entry_qz),
					 0, -1);
					gtk_editable_insert_text(GTK_EDITABLE(entry_qz),
					 string, strlen(string), &ret);
					break;
	    }
		update();
	  gtk_widget_show(cprm);
	  //__________________________________________________________
	 runDialog(&compresslock);
	   
		printf("\n Lock : %d\n",compresslock);
	  if (1 == compresslock)
	    {
		// Get compression mode
		int r1;
		r1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						  (radiobutton1));
		r1 +=
		    2 *
		    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						 (radiobutton2));
	r1 +=
		    4 *
		    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						 (radiobutton3));
		printf("\n Mode: %d",r1);

		switch (r1)
		  {
		  case 2:
		      *mode = COMPRESS_CBR;
//ubr
		      str =
			  gtk_editable_get_chars(GTK_EDITABLE
						 (entry_bitrate), 0, -1);
		      value = (uint32_t) atoi(str);
		      if (value < 3000)
					  value *= 1000;
		      if (value > 300000 && value < 6000000)
			{
			    *br = value;
			    ret = 1;
		      } else
			  ret = 0;
		      break;
		  case 1:
		      *mode = COMPRESS_CQ;
		      str =
			  gtk_editable_get_chars(GTK_EDITABLE(entry_qz), 0,
						 -1);
		      value = (uint32_t) atoi(str);
		      if (value >= 2 && value <= 32)
						{
			    			*qz = value;
			    			ret = 1;
		      	}
		      	else
						{
					printf("\n incorrect Q parameter\n");
				    ret = 0;
						}
		  	    break;
		  case 4:
		     *mode = COMPRESS_2PASS;
		       str=gtk_editable_get_chars(GTK_EDITABLE(entry_size), 0,
						 -1);
		      value = (uint32_t) atoi(str);
        		if((value>0)&&(value<2048))
          		{
       				*fsize=value;
				      	ret=1;
           	}
            	else
             		ret=0;
         		break;
		  default:
		      assert(0);
		  }



	    }
	  	if(compresslock==-2)
		{
			ret=1;
    			printf("\n destroyed ...\n");
			
		}
			else
			{
				//uint8_t sel;
				// grab flag 123									
					  read();				     
              //
		   		gtk_widget_destroy(cprm);
			}

      }
    while (!ret);		// end do
    printf("\n exiting ...\n");
    if(compresslock==1)
			 return 1;
    return 0;

}



GtkWidget*
create_xvidCompression (void)
{
  GtkWidget *xvidCompression;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *vbox11;
  GtkWidget *label42;
  GtkWidget *vbox12;
  GtkWidget *hbox24;
  GtkWidget *label43;
  GtkWidget *vbox13;
  GtkWidget *hbox25;
  GSList *pp_compressmode_group = NULL;
//  GtkWidget *radiobutton1;
  GtkWidget *label44;
//  GtkWidget *entry_qz;
  GtkWidget *hbox26;
//  GtkWidget *radiobutton2;
  GtkWidget *label45;
//  GtkWidget *entry_bitrate;
  GtkWidget *hbox27;
//  GtkWidget *radiobutton3;
  GtkWidget *label46;
//  GtkWidget *entry_size;
  GtkWidget *hbox28;
  GtkWidget *hbox29;
  GtkWidget *label47;
  GtkWidget *label48;
  GtkWidget *label49;
  GtkWidget *hseparator10;
  GtkWidget *hbox30;
//  GtkWidget *optionmenu_quant;
//  GtkWidget *optionmenu_quant_menu;
  GtkWidget *glade_menuitem;
//  GtkWidget *optionmenuME;
//  GtkWidget *optionmenuME_menu;
//  GtkWidget *togglebutton_halfpel;
//  GtkWidget *togglebutton_inter4v;
//  GtkWidget *togglebutton_interlaced;
  GtkWidget *hseparator11;
  GtkWidget *hseparator12;
  GtkWidget *hseparator16;
  GtkWidget *hbox32;
  GtkWidget *label51;
  GtkObject *spinbutton_imin_adj;
//  GtkWidget *spinbutton_imin;
  GtkObject *spinbutton_imax_adj;
//  GtkWidget *spinbutton_imax;
  GtkWidget *label52;
  GtkObject *spinbutton_pmin_adj;
//  GtkWidget *spinbutton_pmin;
  GtkObject *spinbutton_pmax_adj;
//  GtkWidget *spinbutton_pmax;
  GtkWidget *label39;
  GtkWidget *vbox14;
  GtkWidget *hbox38;
  GtkWidget *label61;
  GtkWidget *hbox40;
  GtkWidget *label62;
  GtkWidget *label63;
  GtkWidget *label64;
  GtkWidget *hbox39;
  GtkObject *spinbutton_startstart_adj;
//  GtkWidget *spinbutton_startstart;
  GtkObject *spinbutton_startend_adj;
//  GtkWidget *spinbutton_startend;
  GtkObject *spinbutton_cred_rate_adj;
//  GtkWidget *spinbutton_cred_rate;
  GtkWidget *label68;
  GtkWidget *hbox41;
  GtkWidget *label65;
  GtkWidget *label66;
  GtkWidget *hseparator18;
  GtkWidget *hbox42;
  GtkObject *spinbutton_endstart_adj;
//  GtkWidget *spinbutton_endstart;
  GtkObject *spinbutton_endend_adj;
//  GtkWidget *spinbutton_endend;
  GtkWidget *hseparator17;
  GtkWidget *label40;
  GtkWidget *vbox15;
  GtkWidget *frame1;
  GtkWidget *vbox16;
  GtkWidget *hbox31;
  GtkWidget *label50;
  GtkObject *spinbutton_kfboost_adj;
//  GtkWidget *spinbutton_kfboost;
//  GtkWidget *togglebutton_lumi;
  GtkWidget *hseparator13;
  GtkWidget *hseparator14;
  GtkWidget *hseparator15;
  GtkWidget *hbox43;
  GtkWidget *label69;
  GtkObject *spinbutton_iframeintervall_adj;
//  GtkWidget *spinbutton_iframeintervall;
  GtkWidget *frame2;
  GtkWidget *table1;
  GtkWidget *label70;
  GtkWidget *label71;
  GtkObject *spinbutton_hiscene_adj;
//  GtkWidget *spinbutton_hiscene;
  GtkObject *spinbutton_lowscene_adj;
//  GtkWidget *spinbutton_lowscene;
  GtkWidget *label72;
  GtkObject *spinbutton_payback_adj;
//  GtkWidget *spinbutton_payback;
  GSList *bias_group = NULL;
//  GtkWidget *radiobutton_biaspayback;
//  GtkWidget *radiobutton_proppayback;
  GtkWidget *label41;
  GtkWidget *vbox17;
  GtkWidget *button_load;
  GtkWidget *button_save;
  GtkWidget *label73;
  GtkWidget *table2;
  GtkWidget *label75;
//  GtkWidget *togglebutton_usealt;
  GtkWidget *label76;
  GtkWidget *label77;
  GtkObject *spinbutton_alt_curve_high_dist_adj;
//  GtkWidget *spinbutton_alt_curve_high_dist;
  GtkWidget *label78;
  GtkObject *spinbutton_alt_curve_low_dist_adj;
//  GtkWidget *spinbutton_alt_curve_low_dist;
  GtkWidget *label79;
  GtkObject *spinbutton_strength_adj;
//  GtkWidget *spinbutton_strength;
//  GtkWidget *optionmenu_curve;
//  GtkWidget *optionmenu_curve_menu;
  GtkWidget *label74;
  GtkWidget *dialog_action_area1;
  GtkWidget *button9;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  xvidCompression = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (xvidCompression), "xvidCompression", xvidCompression);
  gtk_window_set_title (GTK_WINDOW (xvidCompression), "Xvid compression");
  gtk_window_set_policy (GTK_WINDOW (xvidCompression), TRUE, TRUE, FALSE);
  gtk_window_set_modal(GTK_WINDOW(xvidCompression), 1);
  dialog_vbox1 = GTK_DIALOG (xvidCompression)->vbox;
  gtk_object_set_data (GTK_OBJECT (xvidCompression), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook1, TRUE, TRUE, 0);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox11);

  label42 = gtk_label_new ("Compression Parameters");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_box_pack_start (GTK_BOX (vbox11), label42, FALSE, FALSE, 0);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (vbox11), vbox12, TRUE, TRUE, 0);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox24, FALSE, FALSE, 0);

  label43 = gtk_label_new ("Mode:");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
  gtk_box_pack_start (GTK_BOX (hbox24), label43, FALSE, FALSE, 0);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox24), vbox13, TRUE, FALSE, 0);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox25, FALSE, FALSE, 0);

  radiobutton1 = gtk_radio_button_new_with_label (pp_compressmode_group, "CQ");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
  gtk_widget_ref (radiobutton1);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "radiobutton1", radiobutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton1);
  gtk_box_pack_start (GTK_BOX (hbox25), radiobutton1, TRUE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);

  label44 = gtk_label_new (", quality ");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_box_pack_start (GTK_BOX (hbox25), label44, TRUE, TRUE, 0);
  gtk_widget_set_usize (label44, 100, -2);

  entry_qz = gtk_entry_new ();
  gtk_widget_ref (entry_qz);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "entry_qz", entry_qz,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_qz);
  gtk_box_pack_start (GTK_BOX (hbox25), entry_qz, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_qz), "6");

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox26, FALSE, FALSE, 0);

  radiobutton2 = gtk_radio_button_new_with_label (pp_compressmode_group, "CBR");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_widget_ref (radiobutton2);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "radiobutton2", radiobutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton2);
  gtk_box_pack_start (GTK_BOX (hbox26), radiobutton2, TRUE, TRUE, 0);

  label45 = gtk_label_new (", bitrate");
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox26), label45, TRUE, TRUE, 0);
  gtk_widget_set_usize (label45, 100, -2);

  entry_bitrate = gtk_entry_new ();
  gtk_widget_ref (entry_bitrate);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "entry_bitrate", entry_bitrate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_bitrate);
  gtk_box_pack_start (GTK_BOX (hbox26), entry_bitrate, TRUE, TRUE, 0);

  hbox27 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox27);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox27", hbox27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox27);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox27, FALSE, FALSE, 0);

  radiobutton3 = gtk_radio_button_new_with_label (pp_compressmode_group, "2-Pass");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
  gtk_widget_ref (radiobutton3);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "radiobutton3", radiobutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton3);
  gtk_box_pack_start (GTK_BOX (hbox27), radiobutton3, TRUE, TRUE, 0);

  label46 = gtk_label_new (", size in MB");
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox27), label46, TRUE, TRUE, 0);

  entry_size = gtk_entry_new ();
  gtk_widget_ref (entry_size);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "entry_size", entry_size,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_size);
  gtk_box_pack_start (GTK_BOX (hbox27), entry_size, TRUE, TRUE, 0);

  hbox28 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox28);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox28", hbox28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox28);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox28, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox28, -2, 14);

  hbox29 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox29);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox29", hbox29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox29);
  gtk_box_pack_start (GTK_BOX (hbox28), hbox29, TRUE, TRUE, 0);

  label47 = gtk_label_new ("  Quantizer  ");
  gtk_widget_ref (label47);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label47", label47,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label47);
  gtk_box_pack_start (GTK_BOX (hbox29), label47, FALSE, FALSE, 0);

  label48 = gtk_label_new ("  Motion Search");
  gtk_widget_ref (label48);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label48", label48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label48);
  gtk_box_pack_start (GTK_BOX (hbox29), label48, FALSE, FALSE, 0);

  label49 = gtk_label_new (" Extra Motion  ");
  gtk_widget_ref (label49);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label49", label49,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label49);
  gtk_box_pack_start (GTK_BOX (hbox29), label49, FALSE, FALSE, 0);

  hseparator10 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator10);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator10", hseparator10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator10);
  gtk_box_pack_start (GTK_BOX (hbox29), hseparator10, FALSE, FALSE, 0);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox30, TRUE, TRUE, 0);

  optionmenu_quant = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu_quant);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "optionmenu_quant", optionmenu_quant,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu_quant);
  gtk_box_pack_start (GTK_BOX (hbox30), optionmenu_quant, FALSE, FALSE, 0);
  gtk_widget_set_usize (optionmenu_quant, -2, 14);
  gtk_tooltips_set_tip (tooltips, optionmenu_quant, "Quant ", NULL);
  optionmenu_quant_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("Mpeg");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_quant_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("H263");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_quant_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_quant), optionmenu_quant_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_quant), 1);

  optionmenuME = gtk_option_menu_new ();
  gtk_widget_ref (optionmenuME);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "optionmenuME", optionmenuME,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenuME);
  gtk_box_pack_start (GTK_BOX (hbox30), optionmenuME, FALSE, FALSE, 0);
  gtk_widget_set_usize (optionmenuME, -2, 14);
  gtk_tooltips_set_tip (tooltips, optionmenuME, "Motion estimation", NULL);
  optionmenuME_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("Zero");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Logarithmic");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Full");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("PMVFast");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("EPZS");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenuME), optionmenuME_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenuME), 4);

  togglebutton_halfpel = gtk_toggle_button_new_with_label ("HalfPel");
  gtk_widget_ref (togglebutton_halfpel);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "togglebutton_halfpel", togglebutton_halfpel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_halfpel);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_halfpel, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_halfpel), TRUE);

  togglebutton_inter4v = gtk_toggle_button_new_with_label ("Inter4v");
  gtk_widget_ref (togglebutton_inter4v);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "togglebutton_inter4v", togglebutton_inter4v,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_inter4v);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_inter4v, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_inter4v), TRUE);

  togglebutton_interlaced = gtk_toggle_button_new_with_label ("Interlacd");
  gtk_widget_ref (togglebutton_interlaced);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "togglebutton_interlaced", togglebutton_interlaced,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_interlaced);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_interlaced, FALSE, FALSE, 0);
  gtk_widget_set_usize (togglebutton_interlaced, 60, -2);

  hseparator11 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator11);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator11", hseparator11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator11);
  gtk_box_pack_start (GTK_BOX (hbox30), hseparator11, TRUE, TRUE, 0);

  hseparator12 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator12);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator12", hseparator12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator12);
  gtk_box_pack_start (GTK_BOX (hbox30), hseparator12, FALSE, FALSE, 0);

  hseparator16 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator16);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator16", hseparator16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator16);
  gtk_box_pack_start (GTK_BOX (vbox11), hseparator16, FALSE, FALSE, 0);

  hbox32 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox32, TRUE, TRUE, 0);

  label51 = gtk_label_new ("IFrame  Q");
  gtk_widget_ref (label51);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label51", label51,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label51);
  gtk_box_pack_start (GTK_BOX (hbox32), label51, FALSE, FALSE, 0);
  gtk_widget_set_usize (label51, 90, -2);

  spinbutton_imin_adj = gtk_adjustment_new (2, 2, 31, 1, 10, 10);
  spinbutton_imin = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_imin_adj), 1, 0);
  gtk_widget_ref (spinbutton_imin);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_imin", spinbutton_imin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_imin);
  gtk_box_pack_start (GTK_BOX (hbox32), spinbutton_imin, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_imin), TRUE);

  spinbutton_imax_adj = gtk_adjustment_new (31, 2, 31, 1, 10, 10);
  spinbutton_imax = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_imax_adj), 1, 0);
  gtk_widget_ref (spinbutton_imax);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_imax", spinbutton_imax,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_imax);
  gtk_box_pack_start (GTK_BOX (hbox32), spinbutton_imax, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_imax), TRUE);

  label52 = gtk_label_new ("PFrame Q");
  gtk_widget_ref (label52);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label52", label52,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label52);
  gtk_box_pack_start (GTK_BOX (hbox32), label52, FALSE, FALSE, 0);

  spinbutton_pmin_adj = gtk_adjustment_new (2, 2, 31, 1, 10, 10);
  spinbutton_pmin = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_pmin_adj), 1, 0);
  gtk_widget_ref (spinbutton_pmin);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_pmin", spinbutton_pmin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_pmin);
  gtk_box_pack_start (GTK_BOX (hbox32), spinbutton_pmin, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_pmin), TRUE);

  spinbutton_pmax_adj = gtk_adjustment_new (31, 2, 31, 1, 10, 10);
  spinbutton_pmax = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_pmax_adj), 1, 0);
  gtk_widget_ref (spinbutton_pmax);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_pmax", spinbutton_pmax,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_pmax);
  gtk_box_pack_start (GTK_BOX (hbox32), spinbutton_pmax, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_pmax), TRUE);

  label39 = gtk_label_new ("General");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label39);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox14);
  gtk_widget_set_sensitive (vbox14, FALSE);

  hbox38 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox38);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox38", hbox38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox38);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox38, TRUE, TRUE, 0);

  label61 = gtk_label_new ("---------------------- Start Credit--------------------");
  gtk_widget_ref (label61);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label61", label61,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label61);
  gtk_box_pack_start (GTK_BOX (hbox38), label61, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label61), TRUE);

  hbox40 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox40);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox40", hbox40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox40);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox40, TRUE, TRUE, 0);

  label62 = gtk_label_new ("Start at frame");
  gtk_widget_ref (label62);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label62", label62,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label62);
  gtk_box_pack_start (GTK_BOX (hbox40), label62, FALSE, FALSE, 0);
  gtk_widget_set_usize (label62, 120, -2);

  label63 = gtk_label_new ("End at frame");
  gtk_widget_ref (label63);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label63", label63,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label63);
  gtk_box_pack_start (GTK_BOX (hbox40), label63, FALSE, FALSE, 0);
  gtk_widget_set_usize (label63, 120, -2);

  label64 = gtk_label_new ("% of quant:");
  gtk_widget_ref (label64);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label64", label64,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label64);
  gtk_box_pack_start (GTK_BOX (hbox40), label64, FALSE, FALSE, 0);
  gtk_widget_set_usize (label64, 120, -2);

  hbox39 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox39);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox39", hbox39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox39);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox39, TRUE, TRUE, 0);

  spinbutton_startstart_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_startstart = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_startstart_adj), 1, 0);
  gtk_widget_ref (spinbutton_startstart);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_startstart", spinbutton_startstart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox39), spinbutton_startstart, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (spinbutton_startstart, FALSE);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_startstart), TRUE);

  spinbutton_startend_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_startend = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_startend_adj), 1, 0);
  gtk_widget_ref (spinbutton_startend);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_startend", spinbutton_startend,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_startend);
  gtk_box_pack_start (GTK_BOX (hbox39), spinbutton_startend, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_startend), TRUE);

  spinbutton_cred_rate_adj = gtk_adjustment_new (20, 0, 100, 1, 10, 10);
  spinbutton_cred_rate = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_cred_rate_adj), 1, 0);
  gtk_widget_ref (spinbutton_cred_rate);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_cred_rate", spinbutton_cred_rate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_cred_rate);
  gtk_box_pack_start (GTK_BOX (hbox39), spinbutton_cred_rate, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_cred_rate), TRUE);

  label68 = gtk_label_new ("---------------------- End Credit--------------------");
  gtk_widget_ref (label68);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label68", label68,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label68);
  gtk_box_pack_start (GTK_BOX (vbox14), label68, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label68), TRUE);

  hbox41 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox41);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox41", hbox41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox41);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox41, TRUE, TRUE, 0);

  label65 = gtk_label_new ("Start at frame");
  gtk_widget_ref (label65);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label65", label65,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label65);
  gtk_box_pack_start (GTK_BOX (hbox41), label65, FALSE, FALSE, 0);
  gtk_widget_set_usize (label65, 120, -2);

  label66 = gtk_label_new ("End at frame");
  gtk_widget_ref (label66);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label66", label66,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label66);
  gtk_box_pack_start (GTK_BOX (hbox41), label66, FALSE, FALSE, 0);
  gtk_widget_set_usize (label66, 120, -2);

  hseparator18 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator18);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator18", hseparator18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator18);
  gtk_box_pack_start (GTK_BOX (hbox41), hseparator18, FALSE, FALSE, 0);

  hbox42 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox42);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox42", hbox42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox42);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox42, TRUE, TRUE, 0);

  spinbutton_endstart_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_endstart = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_endstart_adj), 1, 0);
  gtk_widget_ref (spinbutton_endstart);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_endstart", spinbutton_endstart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_endstart);
  gtk_box_pack_start (GTK_BOX (hbox42), spinbutton_endstart, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_endstart), TRUE);

  spinbutton_endend_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_endend = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_endend_adj), 1, 0);
  gtk_widget_ref (spinbutton_endend);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_endend", spinbutton_endend,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_endend);
  gtk_box_pack_start (GTK_BOX (hbox42), spinbutton_endend, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_endend), TRUE);

  hseparator17 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator17);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator17", hseparator17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator17);
  gtk_box_pack_start (GTK_BOX (hbox42), hseparator17, TRUE, TRUE, 0);

  label40 = gtk_label_new ("Credits");
  gtk_widget_ref (label40);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label40", label40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label40);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label40);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox15);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox15", vbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox15);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox15);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox15), frame1, TRUE, TRUE, 0);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_container_add (GTK_CONTAINER (frame1), vbox16);

  hbox31 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox31);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox31", hbox31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox31);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox31, TRUE, TRUE, 0);

  label50 = gtk_label_new ("Kf Boost");
  gtk_widget_ref (label50);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label50", label50,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label50);
  gtk_box_pack_start (GTK_BOX (hbox31), label50, FALSE, FALSE, 0);
  gtk_widget_set_usize (label50, 60, -2);

  spinbutton_kfboost_adj = gtk_adjustment_new (20, 0, 100, 1, 10, 10);
  spinbutton_kfboost = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_kfboost_adj), 1, 0);
  gtk_widget_ref (spinbutton_kfboost);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_kfboost", spinbutton_kfboost,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_kfboost);
  gtk_box_pack_start (GTK_BOX (hbox31), spinbutton_kfboost, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_kfboost), TRUE);

  togglebutton_lumi = gtk_toggle_button_new_with_label ("LumiMask");
  gtk_widget_ref (togglebutton_lumi);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "togglebutton_lumi", togglebutton_lumi,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_lumi);
  gtk_box_pack_start (GTK_BOX (hbox31), togglebutton_lumi, FALSE, FALSE, 0);
  gtk_widget_set_usize (togglebutton_lumi, -2, 16);

  hseparator13 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator13);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator13", hseparator13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator13);
  gtk_box_pack_start (GTK_BOX (hbox31), hseparator13, TRUE, TRUE, 0);

  hseparator14 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator14);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator14", hseparator14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator14);
  gtk_box_pack_start (GTK_BOX (hbox31), hseparator14, TRUE, TRUE, 0);

  hseparator15 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator15);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hseparator15", hseparator15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator15);
  gtk_box_pack_start (GTK_BOX (hbox31), hseparator15, TRUE, TRUE, 0);

  hbox43 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox43);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "hbox43", hbox43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox43);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox43, TRUE, TRUE, 0);

  label69 = gtk_label_new ("Min I Frame interval :");
  gtk_widget_ref (label69);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label69", label69,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label69);
  gtk_box_pack_start (GTK_BOX (hbox43), label69, FALSE, FALSE, 0);

  spinbutton_iframeintervall_adj = gtk_adjustment_new (6, 0, 500, 1, 10, 10);
  spinbutton_iframeintervall = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_iframeintervall_adj), 1, 0);
  gtk_widget_ref (spinbutton_iframeintervall);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_iframeintervall", spinbutton_iframeintervall,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_iframeintervall);
  gtk_box_pack_start (GTK_BOX (hbox43), spinbutton_iframeintervall, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_iframeintervall), TRUE);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox15), frame2, TRUE, TRUE, 0);

  table1 = gtk_table_new (4, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame2), table1);

  label70 = gtk_label_new ("High Bitrate scene %");
  gtk_widget_ref (label70);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label70", label70,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label70);
  gtk_table_attach (GTK_TABLE (table1), label70, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label70), 0, 0.5);

  label71 = gtk_label_new ("Low Bitrate scene %");
  gtk_widget_ref (label71);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label71", label71,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label71);
  gtk_table_attach (GTK_TABLE (table1), label71, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label71), 0, 0.5);

  spinbutton_hiscene_adj = gtk_adjustment_new (25, 0, 100, 1, 10, 10);
  spinbutton_hiscene = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_hiscene_adj), 1, 0);
  gtk_widget_ref (spinbutton_hiscene);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_hiscene", spinbutton_hiscene,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_hiscene);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_hiscene, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_hiscene), TRUE);

  spinbutton_lowscene_adj = gtk_adjustment_new (10, 0, 100, 1, 10, 10);
  spinbutton_lowscene = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_lowscene_adj), 1, 0);
  gtk_widget_ref (spinbutton_lowscene);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_lowscene", spinbutton_lowscene,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_lowscene);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_lowscene, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_lowscene), TRUE);

  label72 = gtk_label_new ("Payback Delay (frames)");
  gtk_widget_ref (label72);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label72", label72,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label72);
  gtk_table_attach (GTK_TABLE (table1), label72, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label72), 0, 0.5);

  spinbutton_payback_adj = gtk_adjustment_new (240, 0, 500, 1, 10, 10);
  spinbutton_payback = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_payback_adj), 1, 0);
  gtk_widget_ref (spinbutton_payback);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_payback", spinbutton_payback,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_payback);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_payback, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_payback), TRUE);

  radiobutton_biaspayback = gtk_radio_button_new_with_label (bias_group, "Bias Payback");
  bias_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_biaspayback));
  gtk_widget_ref (radiobutton_biaspayback);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "radiobutton_biaspayback", radiobutton_biaspayback,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_biaspayback);
  gtk_table_attach (GTK_TABLE (table1), radiobutton_biaspayback, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radiobutton_proppayback = gtk_radio_button_new_with_label (bias_group, "Prop. payback");
  bias_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_proppayback));
  gtk_widget_ref (radiobutton_proppayback);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "radiobutton_proppayback", radiobutton_proppayback,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_proppayback);
  gtk_table_attach (GTK_TABLE (table1), radiobutton_proppayback, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label41 = gtk_label_new ("2pass Options");
  gtk_widget_ref (label41);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label41", label41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label41);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label41);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox17);

  button_load = gtk_button_new_with_label ("Load");
  gtk_widget_ref (button_load);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "button_load", button_load,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_load);
  gtk_box_pack_start (GTK_BOX (vbox17), button_load, FALSE, FALSE, 0);

  button_save = gtk_button_new_with_label ("Save");
  gtk_widget_ref (button_save);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "button_save", button_save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_save);
  gtk_box_pack_start (GTK_BOX (vbox17), button_save, FALSE, FALSE, 0);

  label73 = gtk_label_new ("Save/Load");
  gtk_widget_ref (label73);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label73", label73,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label73);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), label73);

  table2 = gtk_table_new (5, 2, FALSE);
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (notebook1), table2);

  label75 = gtk_label_new ("Use alternate curve system : ");
  gtk_widget_ref (label75);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label75", label75,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label75);
  gtk_table_attach (GTK_TABLE (table2), label75, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label75), 0, 0.5);

  togglebutton_usealt = gtk_toggle_button_new_with_label ("Yes");
  gtk_widget_ref (togglebutton_usealt);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "togglebutton_usealt", togglebutton_usealt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_usealt);
  gtk_table_attach (GTK_TABLE (table2), togglebutton_usealt, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_usealt), TRUE);

  label76 = gtk_label_new ("Curve Agression :");
  gtk_widget_ref (label76);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label76", label76,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label76);
  gtk_table_attach (GTK_TABLE (table2), label76, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label76), 0, 0.5);

  label77 = gtk_label_new ("High distance from average (%)");
  gtk_widget_ref (label77);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label77", label77,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label77);
  gtk_table_attach (GTK_TABLE (table2), label77, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label77), 0, 0.5);

  spinbutton_alt_curve_high_dist_adj = gtk_adjustment_new (500, 0, 1000, 1, 10, 10);
  spinbutton_alt_curve_high_dist = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_alt_curve_high_dist_adj), 1, 0);
  gtk_widget_ref (spinbutton_alt_curve_high_dist);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_alt_curve_high_dist", spinbutton_alt_curve_high_dist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_alt_curve_high_dist);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_alt_curve_high_dist, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_alt_curve_high_dist), TRUE);

  label78 = gtk_label_new ("Low distance from average (%)");
  gtk_widget_ref (label78);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label78", label78,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label78);
  gtk_table_attach (GTK_TABLE (table2), label78, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label78), 0, 0.5);

  spinbutton_alt_curve_low_dist_adj = gtk_adjustment_new (90, 0, 10000, 1, 10, 10);
  spinbutton_alt_curve_low_dist = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_alt_curve_low_dist_adj), 1, 0);
  gtk_widget_ref (spinbutton_alt_curve_low_dist);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_alt_curve_low_dist", spinbutton_alt_curve_low_dist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_alt_curve_low_dist);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_alt_curve_low_dist, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_alt_curve_low_dist), TRUE);

  label79 = gtk_label_new ("Relative qual Strength (%)");
  gtk_widget_ref (label79);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label79", label79,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label79);
  gtk_table_attach (GTK_TABLE (table2), label79, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label79), 0, 0.5);

  spinbutton_strength_adj = gtk_adjustment_new (50, 0, 100, 1, 10, 10);
  spinbutton_strength = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_strength_adj), 1, 0);
  gtk_widget_ref (spinbutton_strength);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "spinbutton_strength", spinbutton_strength,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_strength);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_strength, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_strength), TRUE);

  optionmenu_curve = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu_curve);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "optionmenu_curve", optionmenu_curve,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu_curve);
  gtk_table_attach (GTK_TABLE (table2), optionmenu_curve, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  optionmenu_curve_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("Soft");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_curve_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Linear");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_curve_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Aggressive");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_curve_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_curve), optionmenu_curve_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_curve), 1);

  label74 = gtk_label_new ("Alt Curving");
  gtk_widget_ref (label74);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "label74", label74,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label74);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 4), label74);

  dialog_action_area1 = GTK_DIALOG (xvidCompression)->action_area;
  gtk_object_set_data (GTK_OBJECT (xvidCompression), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  button9 = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button9);
  gtk_object_set_data_full (GTK_OBJECT (xvidCompression), "button9", button9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button9);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button9, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);
  gtk_signal_connect (GTK_OBJECT (button_load), "clicked",
                      GTK_SIGNAL_FUNC (gui_load),
                      (void *)1);
  gtk_signal_connect (GTK_OBJECT (button_save), "clicked",
                      GTK_SIGNAL_FUNC (gui_save),
                      (void *)1);

  gtk_object_set_data (GTK_OBJECT (xvidCompression), "tooltips", tooltips);

  return xvidCompression;
}


#endif
