/***************************************************************************
                          GUI_info.cpp  -  description
                             -------------------
    begin                : Sat Apr 13 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "avi_vars.h"

void frame2time(uint32_t frame, uint32_t fps, uint16_t * hh, uint16_t * mm,
		uint16_t * ss, uint16_t * ms);

static GtkWidget *create_infowindow(void);
static  GtkWidget *entry_frate;
static GtkWidget *entry_fnbframe;
static GtkWidget *entry_fduration;
static GtkWidget *entry_fid;
static GtkWidget *entry_fcompressor;
static GtkWidget *infowindow;
// audio
static GtkWidget *entry_fmode;
static GtkWidget *entry_ffrequency;
static GtkWidget *entry_fcoding;
static GtkWidget *entry_fsize;

//_____________________________________________________________
void GUI_ShowAviInfo(void)
{
    char text[80];
    uint16_t hh, mm, ss, ms;
    if (playing)
	return;

    text[0] = 0;
    if (!avifileinfo)
	return;
    // fill interesting in bits
    //
    // show window
    //
    {
	infowindow = create_infowindow();
	// now fill in intersting bits
	//
	//
	//
	//
	sprintf(text, "%lu x %lu  ", avifileinfo->width,
		avifileinfo->height);
	gtk_entry_set_text((GtkEntry *) entry_fsize, text);

	sprintf(text, "%2.3f fps", (float) avifileinfo->fps1000 / 1000.F);
	gtk_entry_set_text((GtkEntry *) entry_frate, text);

	sprintf(text, "%ld frames", avifileinfo->nb_frames);
	gtk_entry_set_text((GtkEntry *) entry_fnbframe, text);

	sprintf(text, "%ld frames", avifileinfo->nb_frames);
	gtk_entry_set_text((GtkEntry *) entry_fnbframe, text);
      sprintf(text, "%s ",
		      fourCC::tostring(avifileinfo->fcc));

        /*---*/


	gtk_entry_set_text((GtkEntry *) entry_fcompressor, text);

	if (avifileinfo->nb_frames)
	  {
	      frame2time(avifileinfo->nb_frames, avifileinfo->fps1000,
			 &hh, &mm, &ss, &ms);
	      sprintf(text, "%02d:%02d:%02d.%03d", hh, mm, ss, ms);
	      gtk_entry_set_text((GtkEntry *) entry_fduration, text);

	  }
	// Now audio
	if (wavinfo)
	  {
	      switch (wavinfo->channels)
		{
		case 1:
		    sprintf(text, "MONO");
		    break;
		case 2:
		    sprintf(text, "STEREO");
		    break;
		default:
		    sprintf(text, "????");
		    break;
		}
	      gtk_entry_set_text((GtkEntry *) entry_fmode, text);
	      sprintf(text, "%lu Hz", wavinfo->frequency);
	      gtk_entry_set_text((GtkEntry *) entry_ffrequency, text);
	      sprintf(text, "%lu Bps / %lu kbps", wavinfo->byterate,
		      wavinfo->byterate * 8 / 1000);
	      gtk_entry_set_text((GtkEntry *) entry_fcoding, text);
	      switch (wavinfo->encoding)
		{
		case (WAV_MP3):
		    sprintf(text, "MP3 ");
		    break;
		case (WAV_WMA):
		    sprintf(text, "WMA ");
		    break;
		case (WAV_PCM):
		    sprintf(text, "PCM ");
		    break;
		case (WAV_AC3):
		    sprintf(text, "AC3 ");
		    break;
       case (WAV_OGG):
       	sprintf(text,"OGG");
        	break;
		default:
		    sprintf(text, "?? (0x%2x) ", wavinfo->encoding);
		    break;
		}
	      gtk_entry_set_text((GtkEntry *) entry_fid, text);
	} else
	  {
	      sprintf(text, "NONE");
	      gtk_entry_set_text((GtkEntry *) entry_fmode, text);
	      gtk_entry_set_text((GtkEntry *) entry_ffrequency, text);
	      gtk_entry_set_text((GtkEntry *) entry_fcoding, text);
	      gtk_entry_set_text((GtkEntry *) entry_fid, text);
	  }


	gtk_widget_show(infowindow);
    }

}

GtkWidget *create_infowindow(void)
{
    GtkWidget *vbox2;
    GtkWidget *table1;
    GtkWidget *label1;
    GtkWidget *label2;
    GtkWidget *label3;
    GtkWidget *label4;
    GtkWidget *label5;

    GtkWidget *label6;
    GtkWidget *label7;
    GtkWidget *label8;
    GtkWidget *hseparator1;
    GtkWidget *hseparator2;
    GtkWidget *label9;

    infowindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_object_set_data(GTK_OBJECT(infowindow), "infowindow", infowindow);
    gtk_window_set_title(GTK_WINDOW(infowindow), "AVI infos");
    gtk_window_set_policy(GTK_WINDOW(infowindow), TRUE, TRUE, FALSE);

    vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_widget_show(vbox2);
    gtk_container_add(GTK_CONTAINER(infowindow), vbox2);

    table1 = gtk_table_new(10, 2, FALSE);
    gtk_widget_show(table1);
    gtk_box_pack_start(GTK_BOX(vbox2), table1, TRUE, TRUE, 0);

    label1 = gtk_label_new("Frame Size");
    gtk_widget_show(label1);
    gtk_table_attach(GTK_TABLE(table1), label1, 0, 1, 0, 1,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (GTK_FILL), 0, 0);
    gtk_misc_set_alignment(GTK_MISC(label1), 0, 0.5);

    label2 = gtk_label_new("Frame Rate");
    gtk_widget_show(label2);
    gtk_table_attach(GTK_TABLE(table1), label2, 0, 1, 1, 2,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment(GTK_MISC(label2), 0, 0.5);

    label3 = gtk_label_new("Nb Frames");
    gtk_widget_show(label3);
    gtk_table_attach(GTK_TABLE(table1), label3, 0, 1, 2, 3,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment(GTK_MISC(label3), 0, 0.5);

    label4 = gtk_label_new("Duration");
    gtk_widget_show(label4);
    gtk_table_attach(GTK_TABLE(table1), label4, 0, 1, 3, 4,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment(GTK_MISC(label4), 0, 0.5);

    label5 = gtk_label_new("Compressor");
    gtk_widget_show(label5);
    gtk_table_attach(GTK_TABLE(table1), label5, 0, 1, 4, 5,
		     (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		     0, 0);
    gtk_misc_set_alignment(GTK_MISC(label5), 0, 0.5);

    entry_fsize = gtk_entry_new();
    gtk_widget_show(entry_fsize);
    gtk_table_attach(GTK_TABLE(table1), entry_fsize, 1, 2, 0, 1,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_widget_set_sensitive(entry_fsize, FALSE);
    GTK_WIDGET_UNSET_FLAGS(entry_fsize, GTK_CAN_FOCUS);
    gtk_entry_set_editable(GTK_ENTRY(entry_fsize), FALSE);

    entry_frate = gtk_entry_new();
    gtk_widget_show(entry_frate);
    gtk_table_attach(GTK_TABLE(table1), entry_frate, 1, 2, 1, 2,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_widget_set_sensitive(entry_frate, FALSE);
    GTK_WIDGET_UNSET_FLAGS(entry_frate, GTK_CAN_FOCUS);
    gtk_entry_set_editable(GTK_ENTRY(entry_frate), FALSE);

    entry_fnbframe = gtk_entry_new();
    gtk_widget_show(entry_fnbframe);
    gtk_table_attach(GTK_TABLE(table1), entry_fnbframe, 1, 2, 2, 3,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_widget_set_sensitive(entry_fnbframe, FALSE);
    GTK_WIDGET_UNSET_FLAGS(entry_fnbframe, GTK_CAN_FOCUS);
    gtk_entry_set_editable(GTK_ENTRY(entry_fnbframe), FALSE);

    entry_fduration = gtk_entry_new();
    gtk_widget_show(entry_fduration);
    gtk_table_attach(GTK_TABLE(table1), entry_fduration, 1, 2, 3, 4,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_widget_set_sensitive(entry_fduration, FALSE);
    GTK_WIDGET_UNSET_FLAGS(entry_fduration, GTK_CAN_FOCUS);
    gtk_entry_set_editable(GTK_ENTRY(entry_fduration), FALSE);

    entry_fcompressor = gtk_entry_new();
    gtk_widget_show(entry_fcompressor);
    gtk_table_attach(GTK_TABLE(table1), entry_fcompressor, 1, 2, 4, 5,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_widget_set_sensitive(entry_fcompressor, FALSE);
    GTK_WIDGET_UNSET_FLAGS(entry_fcompressor, GTK_CAN_FOCUS);
    gtk_entry_set_editable(GTK_ENTRY(entry_fcompressor), FALSE);

    label6 = gtk_label_new("Mode");
    gtk_widget_show(label6);
    gtk_table_attach(GTK_TABLE(table1), label6, 0, 1, 6, 7,
		     (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		     0, 0);
    gtk_misc_set_alignment(GTK_MISC(label6), 0, 0.5);

    label7 = gtk_label_new("Frequency");
    gtk_widget_show(label7);
    gtk_table_attach(GTK_TABLE(table1), label7, 0, 1, 7, 8,
		     (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		     0, 0);
    gtk_misc_set_alignment(GTK_MISC(label7), 0, 0.5);

    label8 = gtk_label_new("Coding");
    gtk_widget_show(label8);
    gtk_table_attach(GTK_TABLE(table1), label8, 0, 1, 8, 9,
		     (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		     0, 0);
    gtk_misc_set_alignment(GTK_MISC(label8), 0, 0.5);

    entry_fmode = gtk_entry_new();
    gtk_widget_show(entry_fmode);
    gtk_table_attach(GTK_TABLE(table1), entry_fmode, 1, 2, 6, 7,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_editable(GTK_ENTRY(entry_fmode), FALSE);

    entry_ffrequency = gtk_entry_new();
    gtk_widget_show(entry_ffrequency);
    gtk_table_attach(GTK_TABLE(table1), entry_ffrequency, 1, 2, 7, 8,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_editable(GTK_ENTRY(entry_ffrequency), FALSE);

    entry_fcoding = gtk_entry_new();
    gtk_widget_show(entry_fcoding);
    gtk_table_attach(GTK_TABLE(table1), entry_fcoding, 1, 2, 8, 9,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_editable(GTK_ENTRY(entry_fcoding), FALSE);

    hseparator1 = gtk_hseparator_new();
    gtk_widget_show(hseparator1);
    gtk_table_attach(GTK_TABLE(table1), hseparator1, 0, 1, 5, 6,
		     (GtkAttachOptions) (GTK_FILL),
		     (GtkAttachOptions) (GTK_SHRINK | GTK_FILL), 0, 0);

    hseparator2 = gtk_hseparator_new();
    gtk_widget_show(hseparator2);
    gtk_table_attach(GTK_TABLE(table1), hseparator2, 1, 2, 5, 6,
		     (GtkAttachOptions) (GTK_FILL),
		     (GtkAttachOptions) (GTK_SHRINK | GTK_FILL), 0, 0);

    label9 = gtk_label_new("Id");
    gtk_widget_show(label9);
    gtk_table_attach(GTK_TABLE(table1), label9, 0, 1, 9, 10,
		     (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		     0, 0);
    gtk_misc_set_alignment(GTK_MISC(label9), 0, 0.5);

    entry_fid = gtk_entry_new();
    gtk_widget_show(entry_fid);
    gtk_table_attach(GTK_TABLE(table1), entry_fid, 1, 2, 9, 10,
		     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		     (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_editable(GTK_ENTRY(entry_fid), FALSE);

    return infowindow;
}
