/***************************************************************************
                          GUI_xvcd.cpp  -  description
			  
Shrinked down version of ffmpeg options
Most options are hardcoded			  
                             -------------------
    begin                : Tue Sep 10 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <config.h>
#include "ADM_lavcodec.h"

#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <assert.h>
#include <math.h>

#include "ADM_library/default.h"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_encoder/ADM_vidEncode.hxx"


#include "ADM_codecs/ADM_ffmpegConfig.h"
#include "ADM_toolkit/toolkit.hxx"
#ifdef USE_FFMPEG



extern uint8_t getRangeInMenu(GtkWidget *w);

int getXvcdCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf);

static GtkWidget	*create_xvcdCompression (void);
		      
		      
static void gui_ok(GtkButton * button, gpointer user_data);
static void gui_del(GtkButton * button, gpointer user_data);
static GtkWidget *create_xvcdCompression (void);

static int compresslock;

static GtkWidget *radiobutton1;
static GtkWidget *radiobutton2;
static GtkWidget *radiobutton3;
static GtkWidget *entry_qz;
static GtkWidget *entry_bitrate;
static GtkWidget *entry_size;


 
void gui_del(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    gui_ok(NULL, (gpointer) -1);
}


void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (compresslock)
	return;			// second call back->ignore.
    switch (res)
      {
      case 1:
	  compresslock = 1;
	  //gtk_hide_widget(wdg);

	  break;
      case 0:
	  compresslock = -1;
	  break;
      case -1:
     	compresslock=-2;
      	break;
       default:
       		assert(0);
      }
    return;

};


int getXvcdCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf)
{
    UNUSED_ARG(conf);
    static GtkWidget *cprm;
    char *str;
    char string[100];
    uint32_t value;
    int ret = 0;
    //int firstTime=0;
    
  
    	

    do
      {
	  compresslock = 0;
	  cprm = create_xvcdCompression();
	  //
	  switch (*mode)
	    {
	    	case COMPRESS_CBR:

			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
						 (radiobutton2), 1);
			sprintf(string, "%d", (int) *br/1000);
			gtk_editable_insert_text(GTK_EDITABLE(entry_bitrate),
					 string, strlen(string), &ret);
			break;

		case COMPRESS_2PASS:
		    	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
						 	(radiobutton3), 1);

			sprintf(string, "%d", (int) *fsize );
			gtk_editable_insert_text(GTK_EDITABLE(entry_size),
				 string, strlen(string), &ret);
			break;

	    	case COMPRESS_CQ:
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
					     (radiobutton1), 1);

			sprintf(string, "%d", (int) *qz);
			gtk_editable_insert_text(GTK_EDITABLE(entry_qz),
					 string, strlen(string), &ret);
			break;
	  	default:
	  		assert(0);		
	    }
	 
	
	 gtk_widget_show(cprm);
	  //__________________________________________________________
	  runDialog(&compresslock);
	  //__________________________________________________________
	  
	  if (1 == compresslock)
	    {
		// Get compression mode
		int r1;
		r1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						  (radiobutton1));
		r1 +=
		    2 *
		    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						 (radiobutton2));
	r1 +=
		    4 *
		    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						 (radiobutton3));
		printf("\n Mode: %d",r1);

		switch (r1)
		  {
		  case 2:
		      *mode = COMPRESS_CBR;
//ubr
		      str =
			  gtk_editable_get_chars(GTK_EDITABLE
						 (entry_bitrate), 0, -1);
		      value = (uint32_t) atoi(str);
		      if (value < 3000)
			  value *= 1000;
		      if (value > 16 && value < 6000000)
			{
			    *br = value;
			    ret = 1;
		      } else
			  ret = 0;
		      break;
		  case 1:
		      *mode = COMPRESS_CQ;
		      str =
			  gtk_editable_get_chars(GTK_EDITABLE(entry_qz), 0,
						 -1);
		      value = (uint32_t) atoi(str);
		      if (value >= 2 && value <= 32)
						{
			    			*qz = value;
			    			ret = 1;
		      	}
		      	else
						{
					printf("\n incorrect Q parameter\n");
				    ret = 0;
						}
		  	    break;
		  case 4:
		     *mode = COMPRESS_2PASS;
		       str=gtk_editable_get_chars(GTK_EDITABLE(entry_size), 0,
						 -1);
		      value = (uint32_t) atoi(str);
        		if((value>0)&&(value<2048))
          		{
       				*fsize=value;
				      	ret=1;
           	}
            	else
             		ret=0;
         		break;
		  default:
		      assert(0);
		  }



	    }
	    switch(compresslock)
	    {
	    	case -2:
			ret=1;
    			printf("\n destroyed ...\n");
			break;
	    	case 1:
//			get(); // no break ! not an error !
		case -1:              
		   	gtk_widget_destroy(cprm);
			break;
		default:assert(0);
	    }

      }
    while (!ret);		// end do
    printf("\n qz : %ld \n",*qz);
    printf("\n br : %ld \n",*br);
    printf("\n 2p : %ld \n",*fsize);
    if(compresslock==1) return 1;
    return 0;

}

GtkWidget*
create_xvcdCompression (void)
{
  GtkWidget *xvcdCompression;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *vbox11;
  GtkWidget *label42;
  GtkWidget *vbox12;
  GtkWidget *hbox24;
  GtkWidget *label43;
  GtkWidget *vbox13;
  GtkWidget *hbox25;
  GSList *pp_compressmode_group = NULL;
 // GtkWidget *radiobutton1;
  GtkWidget *label44;
//  GtkWidget *entry_qz;
  GtkWidget *hbox26;
 // GtkWidget *radiobutton2;
  GtkWidget *label45;
//  GtkWidget *entry_bitrate;
  GtkWidget *hbox27;
//  GtkWidget *radiobutton3;
  GtkWidget *label46;
//  GtkWidget *entry_size;
  GtkWidget *hseparator24;
  GtkWidget *hseparator25;
  GtkWidget *hseparator26;
  GtkWidget *hseparator27;
  GtkWidget *label39;
  GtkWidget *dialog_action_area1;
  GtkWidget *button9;

  xvcdCompression = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (xvcdCompression), "xvcdCompression", xvcdCompression);
  gtk_window_set_title (GTK_WINDOW (xvcdCompression), "XVCD compression");
  gtk_window_set_modal (GTK_WINDOW (xvcdCompression), TRUE);
  gtk_window_set_policy (GTK_WINDOW (xvcdCompression), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (xvcdCompression)->vbox;
  gtk_object_set_data (GTK_OBJECT (xvcdCompression), "dialog_vbox1", dialog_vbox1);
  
     gtk_object_set_data_full(GTK_OBJECT(xvcdCompression),
			     "dialog_vbox1",
			     dialog_vbox1,
			     (GtkDestroyNotify) gui_del);
  
  gtk_widget_show (dialog_vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook1, TRUE, TRUE, 0);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox11);

  label42 = gtk_label_new ("Compression Parameters");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_box_pack_start (GTK_BOX (vbox11), label42, FALSE, FALSE, 0);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (vbox11), vbox12, TRUE, TRUE, 0);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox24, FALSE, FALSE, 0);

  label43 = gtk_label_new ("Mode:");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
  gtk_box_pack_start (GTK_BOX (hbox24), label43, FALSE, FALSE, 0);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox24), vbox13, TRUE, FALSE, 0);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox25, FALSE, FALSE, 0);

  radiobutton1 = gtk_radio_button_new_with_label (pp_compressmode_group, "CQ");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
  gtk_widget_ref (radiobutton1);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "radiobutton1", radiobutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton1);
  gtk_box_pack_start (GTK_BOX (hbox25), radiobutton1, TRUE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);

  label44 = gtk_label_new (", quality ");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_box_pack_start (GTK_BOX (hbox25), label44, TRUE, TRUE, 0);
  gtk_widget_set_usize (label44, 100, -2);

  entry_qz = gtk_entry_new ();
  gtk_widget_ref (entry_qz);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "entry_qz", entry_qz,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_qz);
  gtk_box_pack_start (GTK_BOX (hbox25), entry_qz, TRUE, TRUE, 0);
  //gtk_entry_set_text (GTK_ENTRY (entry_qz), "6");

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox26, FALSE, FALSE, 0);

  radiobutton2 = gtk_radio_button_new_with_label (pp_compressmode_group, "CBR");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_widget_ref (radiobutton2);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "radiobutton2", radiobutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton2);
  gtk_box_pack_start (GTK_BOX (hbox26), radiobutton2, TRUE, TRUE, 0);

  label45 = gtk_label_new (", bitrate");
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox26), label45, TRUE, TRUE, 0);
  gtk_widget_set_usize (label45, 100, -2);

  entry_bitrate = gtk_entry_new ();
  gtk_widget_ref (entry_bitrate);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "entry_bitrate", entry_bitrate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_bitrate);
  gtk_box_pack_start (GTK_BOX (hbox26), entry_bitrate, TRUE, TRUE, 0);

  hbox27 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox27);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hbox27", hbox27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox27);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox27, FALSE, FALSE, 0);

  radiobutton3 = gtk_radio_button_new_with_label (pp_compressmode_group, "2-Pass");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
  gtk_widget_ref (radiobutton3);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "radiobutton3", radiobutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton3);
  gtk_box_pack_start (GTK_BOX (hbox27), radiobutton3, TRUE, TRUE, 0);

  label46 = gtk_label_new (", size in MB");
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox27), label46, TRUE, TRUE, 0);

  entry_size = gtk_entry_new ();
  gtk_widget_ref (entry_size);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "entry_size", entry_size,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_size);
  gtk_box_pack_start (GTK_BOX (hbox27), entry_size, TRUE, TRUE, 0);
  //gtk_entry_set_text (GTK_ENTRY (entry_size), "700");

  hseparator24 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator24);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hseparator24", hseparator24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator24);
  gtk_box_pack_start (GTK_BOX (vbox12), hseparator24, TRUE, TRUE, 0);

  hseparator25 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator25);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hseparator25", hseparator25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator25);
  gtk_box_pack_start (GTK_BOX (vbox12), hseparator25, TRUE, TRUE, 0);

  hseparator26 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator26);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hseparator26", hseparator26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator26);
  gtk_box_pack_start (GTK_BOX (vbox11), hseparator26, FALSE, FALSE, 0);

  hseparator27 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator27);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "hseparator27", hseparator27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator27);
  gtk_box_pack_start (GTK_BOX (vbox11), hseparator27, TRUE, TRUE, 0);

  label39 = gtk_label_new ("General");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label39);

  dialog_action_area1 = GTK_DIALOG (xvcdCompression)->action_area;
  gtk_object_set_data (GTK_OBJECT (xvcdCompression), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  button9 = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button9);
  gtk_object_set_data_full (GTK_OBJECT (xvcdCompression), "button9", button9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button9);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button9, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);

  return xvcdCompression;
}

#endif
