/***************************************************************************
                          ADM_mpeglibio.cpp  -  description
                             -------------------
    begin                : Thu Oct 24 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
    
    This part is the interface between avidemux and libmpeg2
    It is only place where we use mpeg2dec as mpeg2dec_t and not as void *
    
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include "config.h"
#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#ifdef __FreeBSD__
#include <sys/types.h>
#endif
#include <stdlib.h>

#include <assert.h>
#include <string.h>
#include <math.h>

#include "ADM_library/default.h"



#include "avifmt.h"
#include "avifmt2.h"

#include "ADM_editor/ADM_Video.h"
#include "ADM_audio/aviaudio.hxx"

#include "ADM_library/fourcc.h"
#include "ADM_mpeg2dec/ADM_mpegscan.h"
#include "ADM_toolkit/toolkit.hxx"

extern "C"
{
#include "libMpeg2Dec/video_out.h"
#include "libMpeg2Dec/mpeg2.h"
#include "libMpeg2Dec/mm_accel.h"
void mpeg2_pop(mpeg2dec_t *m);
void mpeg2_popI(mpeg2dec_t *m);
int parse_chunk (mpeg2dec_t * mpeg2dec, int code,   			       uint8_t * buffer);
};
//static vo_open_t *output_open = NULL;
static vo_instance_t *output;
extern vo_instance_t *vo_yv12_open (void);

//mpeg2dec_t mpeg2dec;
#define MPEG2DEC  ((mpeg2dec_t *)_decoder)


//____________________init ____________________

uint8_t mpeg2decHeader::init_codec (void)
{
  int accel=0;
#ifdef USE_MMX
	accel=MM_ACCEL_X86_MMX;
#endif	  
  printf ("\n initializing mpeg2 decoder");
  output = vo_yv12_open ();
  _decoder=(void *)malloc(sizeof( mpeg2dec_t));
  mpeg2_init (MPEG2DEC, accel | MM_ACCEL_MLIB, output);
  printf ("\n done\n");
  return 1;
}

//____________________-un init ____________________
uint8_t mpeg2decHeader::kill_codec (void)
{
  mpeg2_close (MPEG2DEC);
  free( _decoder);
  _decoder=NULL;
  vo_close (output);

  return 1;
}

uint8_t  mpeg2decHeader::pop (void)
{
		mpeg2_pop(MPEG2DEC);
		return 1;
}
uint8_t mpeg2decHeader::popI (void)
{
	mpeg2_popI(MPEG2DEC);
	return 1;
}
void  mpeg2decHeader::decode_mpeg2 (uint8_t * buf, uint8_t * end)
{
 
  _frame_in_queue += mpeg2_decode_data (MPEG2DEC, buf, end);  
}
