/***************************************************************************
                          filesel.cpp  -  description

		Handle file selector
		A bit clumsy but i assume only one is running at a time
                             -------------------
    begin                : Sun Nov 11 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <pthread.h>
#include <unistd.h>
#include "avi_vars.h"
#include "toolkit.hxx"
#include "filesel.h"
#define TH_READ 1
#define TH_WRITE 2

//_______________
static void filesel_ok(GtkFileSelection * selector, gpointer user_data);
static void filesel_cancel(GtkFileSelection * selector,
			   gpointer user_data);
static void start_thread(void *ptr);
//static void fsUpdate(char *nw);
//
typedef void *FCT_VOID(void *);

//
/* The file selection widget and the string to store the chosen filename */
static GtkWidget *file_selector;
static int th_running = 0;
static int th_type = 0;
static SELFILE_CB *_callback;
static const gchar *_label;
static gchar old_path[400];
static gchar selected_file[400];
static uint8_t has_old_path = 0;
static uint8_t complete;

//
//   Call back for file effectively selected
//
//____________________________
void filesel_ok(GtkFileSelection * selector, gpointer user_data)
{
    UNUSED_ARG(selector);
    UNUSED_ARG(user_data);
    gchar *selected_filename;

    if (th_running)
			return;
    // hide file selctor
    // unlock lock
    th_running = 1;
    complete=1;
    gtk_widget_hide(file_selector);
    while (gtk_events_pending())
      {
	 			 gtk_main_iteration();
      }


    // retrieve filename
    selected_filename =	gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_selector));
    if (*(selected_filename + strlen(selected_filename) - 1) == '/')
      {				// dir !
	  					GUI_Alert("Cannot open directory as file !");
	       			complete=0;
	        	  return;
      }
  	strcpy(selected_file,selected_filename);

}

//
//   Call back for file canceled
//
//____________________________

void filesel_cancel(GtkFileSelection * selector, gpointer user_data)
{
    UNUSED_ARG(selector);
    UNUSED_ARG(user_data);
    th_running = -1;		// allow lock
    complete=0;

}

//___________________________________________
//   Thread handling the file-selection stuff
//   Avoid blocks
//___________________________________________
  // typedef void SELFILE_CB(char *);
void start_thread(void *ptr)
{
    UNUSED_ARG(ptr);
 	FILE *fd;
    file_selector = gtk_file_selection_new(_label);
    // set working dir if exists
    if (has_old_path)
				gtk_file_selection_set_filename(GTK_FILE_SELECTION(file_selector),
					old_path);
    //
    gtk_signal_connect(GTK_OBJECT
		       (GTK_FILE_SELECTION(file_selector)->ok_button),
		       "clicked", GTK_SIGNAL_FUNC(filesel_ok),
		       (gpointer) _callback);

    /* Ensure that the dialog box is destroyed when the user clicks a button. */

    gtk_signal_connect_object(GTK_OBJECT
			      (GTK_FILE_SELECTION(file_selector)->
			       ok_button), "clicked",
			      GTK_SIGNAL_FUNC(filesel_ok),
			      (GtkObject *) file_selector);
    gtk_signal_connect_object(GTK_OBJECT
			      (GTK_FILE_SELECTION(file_selector)->
			       cancel_button), "clicked",
			      GTK_SIGNAL_FUNC(filesel_cancel),
			      (GtkObject *) file_selector);

    /* Display that dialog */
     th_running=0;
    gtk_window_set_modal(GTK_WINDOW(file_selector), 1);
    gtk_widget_show(file_selector);       
    runDialog(&th_running);	
    if (file_selector)
				gtk_widget_destroy(file_selector);
		file_selector = NULL;
    if(th_running==1)
    {
			th_running=0; 		
		// now call callback
		switch(th_type)
			{
					case TH_READ: // check file is readable
									
												fd=fopen(selected_file,"rb");
												if(!fd)
													{
															GUI_Alert("Cannot open this file !");
															return;
													}
													fclose(fd);
													_callback(selected_file);
													break;
				case TH_WRITE:
												
												fd=fopen(selected_file,"rb");
												if(fd)
													{
															fclose(fd);
															if(!GUI_Question("Overwrite file ?"))
																	return;
													}
													_callback(selected_file);
													break;
					default:
													assert(0);												
									
					}											
				
				
			}
			th_running=0;
}

//
//
//________________________________________

void GUI_FileSelWrite(const char *label, SELFILE_CB * cb, int rw)
{				/* Create the selector */
    FCT_VOID *rt;
    if (th_running)
    {
				printf("\n Already running\n");
				return;
		}
    th_running = 1;
    _callback = cb;
    _label = label;
    if (rw == 0)
	th_type = TH_READ;
    else
	th_type = TH_WRITE;

    rt = (FCT_VOID *) & start_thread;
    //      pthread_create(&tid,NULL,rt,NULL);
    start_thread(NULL);
}

void GUI_FileSelRead(const char *label, SELFILE_CB * cb)
{				/* Create the selector */
    GUI_FileSelWrite(label, cb, 0);
}

/*
void fsUpdate(char *nw)
{
    uint32_t k;
    strcpy(old_path, nw);
    has_old_path = 1;
    k = strlen(nw) - 1;
    while (*(old_path + k) != '/')
	k--;
    *(old_path + k + 1) = 0;
}
*/
// EOF
