/***************************************************************************
                          ADM_guiRotate.cpp  -  description
                             -------------------
    begin                : Sat Jan 8 2003
    copyright            : (C) 2003 by Tracy Harton
    email                : tracy@amphibious.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>
#include <math.h>


#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER


#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_vidRotate.h"

extern void yv12rgb(uint8_t *in,uint8_t *out,uint32_t w, uint32_t h);
extern void GUI_RGBDisplay(uint8_t * dis, uint32_t w, uint32_t h, void *widg);

static void 				gui_ok(GtkButton * button, gpointer user_data);
static int 					getRotateParams(	void);
																				
static GtkWidget*  create_dialog1 (void);
static gboolean  			gui_draw(GtkWidget * widget,
	     GdkEventExpose * event, gpointer user_data);

static int croplock;

static  GtkWidget *drawing=NULL;
//static  GtkWidget *hscale3=NULL;
static  GtkWidget *hscale2=NULL;
static  GtkObject *adj_angle=NULL;    


static void gui_update(GtkButton * button, gpointer user_data);


// Ugly !
static uint8_t *video_yuv_orig, *video_rgb, *video_yuv;
static uint32_t orig_w, orig_h;
static ROTATE_PARAM par;

void *ADMVideoRotate::configure( AVDMGenericVideoStream *instream)

{
  uint32_t w,h,l,f;

  printf("\n .. configuring rotate...\n");
  video_rgb = NULL;
  video_yuv_orig = NULL;
  video_yuv = NULL;

  // Get info from previous filter
  w= _in->getInfo()->width;
  h= _in->getInfo()->height;

						  
  video_yuv_orig=(uint8_t *)malloc(w*h*3);							
  assert(video_yuv_orig);
  video_rgb=(uint8_t *)malloc(w*h*3);							
  assert(video_rgb);
  video_yuv=(uint8_t *)malloc(w*h*3);							
  assert(video_yuv);
							
  // ask current frame from previous filter
  assert(instream->getFrameNumberNoAlloc(curframe, &l, video_yuv_orig, &f));
						
  memcpy(video_yuv, video_yuv_orig, (w*h*3)>>1);
  yv12rgb(video_yuv, video_rgb, w, h);
				
  assert(_param);			
  memcpy(&par,_param,sizeof(par));


  orig_w = par.width = w;
  orig_h = par.height = h;
		
  switch(getRotateParams())
  {
    case 0:
    printf("cancelled\n");	       	
    break;
    case 1:
    memcpy(_param,&par,sizeof(par));
    break;
    default:
    assert(0);
  }

  _info.width = _param->width;
  _info.height = _param->height;
		
  free(video_rgb);
  free(video_yuv_orig);
  free(video_yuv);
  
  video_rgb = video_yuv_orig = video_yuv = NULL;

  return (void *)_param;
}

//
//
int getRotateParams(	void )
{
  static 	GtkWidget *resi;
	
  do
  {
    croplock=0;
    resi=create_dialog1();
    gtk_widget_set_usize(drawing, par.width, par.height);		

    /*
    Update value
    */		      
    GTK_ADJUSTMENT(adj_angle)->value= par.angle ;

    gtk_widget_show(resi);
                   
    while(!croplock)
      gtk_main_iteration();

    // now check parameters
    //
    if(1==croplock) //         ok button
    {
      par.angle = GTK_ADJUSTMENT(adj_angle)->value;

      printf("\n Angle : %3.2f\n", par.angle);
    }

      // cancel button
      if(croplock!=-1)
       gtk_widget_destroy(resi);

    }while(!croplock);

    // exit ok
    if(croplock==1)
      return 1;

  return 0;
}

//
void gui_update(GtkButton * button, gpointer user_data)
{
  UNUSED_ARG(button);
  UNUSED_ARG(user_data);
  
  par.angle = GTK_ADJUSTMENT(adj_angle)->value;
  printf("\n Angle : %3.2f\n", par.angle);

  do_rotate(video_yuv_orig, orig_w, orig_h, par.angle, video_yuv, &par.width, &par.height);

  printf("w: %ld, h: %ld\n", par.width, par.height);

  yv12rgb(video_yuv, video_rgb, par.width, par.height);

  gtk_widget_set_usize(drawing, par.width, par.height);		
  GUI_RGBDisplay(video_rgb, par.width, par.height,( void *)drawing);
}

gboolean  gui_draw(GtkWidget * widget, GdkEventExpose * event, gpointer user_data)
{
  UNUSED_ARG(widget);
  UNUSED_ARG(event);
  UNUSED_ARG(user_data);

  GUI_RGBDisplay(video_rgb, par.width, par.height, (void *)drawing);

  return true;
}

void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    
    int res;

    res = (int) user_data;
    if (croplock) return;			// second call back->ignore.
			
    switch (res)
    {
    case 1:
        croplock = 1;
    break;
    case 0:
        croplock = -2;
    break;
    }
    return;

};

 
GtkWidget*  create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *vbox3;
  GtkWidget *vbox4;
  GtkWidget *label1;
  GtkWidget *vbox5;
  GtkWidget *vbox2;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  GtkWidget *button_update;

  dialog1 = gtk_dialog_new (); 
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "Rotate");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox3, TRUE, TRUE, 0);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), vbox4, TRUE, TRUE, 0);

  label1 = gtk_label_new ("Angle");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox4), label1, FALSE, FALSE, 0);

  // angle  _______________________________________________________________
  adj_angle=gtk_adjustment_new (0.0, 0.0, 360.0, 90.0, 90.0, 90.0);
  hscale2 = gtk_hscale_new (GTK_ADJUSTMENT (adj_angle));
  gtk_widget_ref (hscale2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hscale2", hscale2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hscale2);
  gtk_box_pack_start (GTK_BOX (vbox4), hscale2, TRUE, TRUE, 0);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox3), vbox5, TRUE, TRUE, 0);

//  gtk_box_pack_start (GTK_BOX (vbox5), hscale3, TRUE, TRUE, 0);
//  gtk_scale_set_digits (GTK_SCALE (hscale3), 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox2, TRUE, TRUE, 0);

  drawing = gtk_drawing_area_new ();
  gtk_widget_ref (drawing);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "drawing", drawing,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawing);
  gtk_box_pack_start (GTK_BOX (vbox1), drawing, TRUE, TRUE, 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ok, FALSE, FALSE, 0);

  button_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_cancel", button_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_cancel);
  gtk_box_pack_start (GTK_BOX (hbox1), button_cancel, FALSE, FALSE, 0);

  button_update = gtk_button_new_with_label ("Update");
  gtk_widget_ref (button_update);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_update", button_update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_update);
  gtk_box_pack_start (GTK_BOX (hbox1), button_update, FALSE, FALSE, 0);

//-------------------------------------------  
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);
  gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)0);

  gtk_signal_connect (GTK_OBJECT (button_update), "clicked",
                      GTK_SIGNAL_FUNC (gui_update),
                      NULL);

  gtk_signal_connect(GTK_OBJECT(drawing), "expose_event",
		       GTK_SIGNAL_FUNC(gui_draw),
		       NULL); 
  
   
  /*gtk_signal_connect(GTK_OBJECT(hscale3), "drag_data_received",
		       GTK_SIGNAL_FUNC(gui_update), NULL);*/
  gtk_signal_connect(GTK_OBJECT(hscale2), "drag_data_received",
		       GTK_SIGNAL_FUNC(gui_update), NULL);
		       
  /*gtk_signal_connect(GTK_OBJECT(hscale3), "drag_motion",
		       GTK_SIGNAL_FUNC(gui_update), NULL);*/
  gtk_signal_connect(GTK_OBJECT(hscale2), "drag_motion",
		       GTK_SIGNAL_FUNC(gui_update), NULL);		       

  /*gtk_signal_connect(GTK_OBJECT(hscale3), "drag_data_get",
		       GTK_SIGNAL_FUNC(gui_update), NULL);*/
  gtk_signal_connect(GTK_OBJECT(hscale2), "drag_data_get",
		       GTK_SIGNAL_FUNC(gui_update), NULL);	
   	
  /*gtk_signal_connect(GTK_OBJECT(hscale3), "drag_begin",
		       GTK_SIGNAL_FUNC(gui_update), NULL);*/
  gtk_signal_connect(GTK_OBJECT(hscale2), "drag_begin",
		       GTK_SIGNAL_FUNC(gui_update), NULL);	 
		       
  gtk_signal_connect(GTK_OBJECT(adj_angle), "value_changed",
		       GTK_SIGNAL_FUNC(gui_update), (void *) (NULL));
		            
		                      
  
  return dialog1;
}

#endif
