/***************************************************************************
                          ADM_vidFont.cpp  -  description
                             -------------------
    begin                : Sun Dec 15 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 #include <stdio.h>
 #include <stdlib.h>

     
 #include "config.h"
 #ifdef USE_FREETYPE
 
 #include <ft2build.h>
 #include FT_FREETYPE_H
 
 

static    FT_Library   library;   /* handle to library     */
static    FT_Face      face;      /* handle to face object */
static 		int initialized=0; // 0 No init at all, 1 engine inited, 2 -> + font loaded

int initFreeType( char *fontname )
{
int error;
	printf("\n ** Initializing FreeType **\n");
	if(initialized==0) 
	{

    		error = FT_Init_FreeType( &library );
    		if ( error ) 
    		{
			  printf("\n Error Initializing Free Type (%d)\n",error);
			  return 0;
		  }
	}
	initialized=1;
    error = FT_New_Face( library,
                         fontname,
                         0,
                         &face );
    if ( error == FT_Err_Unknown_File_Format )
    {
   	   	printf("\n Error unknown font format (%d)\n",error);
			  return 0;
   
    }
    else if ( error )
    {
     	printf("\n Error unknown error (font %d)\n",error);
			  return 0;
    }
    
/*
    error = FT_Set_Char_Size(
              face,    / handle to face object           /
              0,       / char_width in 1/64th of points  /
              16*64,   / char_height in 1/64th of points /
              300,     / horizontal device resolution    /
              300 );   / vertical device resolution      /

  */  

    error = FT_Set_Pixel_Sizes(
              face,   /* handle to face object            */
              0,      /* pixel_width                      */
              16 );   /* pixel_height                     */


 		initialized=2;
	printf("\n **  FreeType Initialized **\n");		
   	return 1;
}
//____________________________________________________
int fontSetSize ( int size)
{
int error;
	if(initialized!=2)
		{
				printf("\n not initialized");
				return 0;
		}
	   error = FT_Set_Pixel_Sizes(
              face,   /* handle to face object            */
              0,      /* pixel_width                      */
              size );   /* pixel_height                     */
	return 1;
}
//____________________________________________________

int fontDraw(char *target, char c, int stride, int size,int *ww)
{

		
			if(initialized!=2) return 0;
FT_GlyphSlot  slot = face->glyph;  // a small shortcut		
int  glyph_index,error;
int carac=0;
			
        if((unsigned char)(c)==0x92) c='\''; // replace ' 
	// special french stuff
	/*
	if(( char)(c)=='') c='e'; // replace ' 
	if(( char)(c)=='') c='e'; // replace ' 
	if(( char)(c)=='') c='a'; // replace ' 
	if(( char)(c)=='') c='c'; // replace ' */
	
	carac=( int)(unsigned char)c;
	//printf("%c->%d\n",c,carac);
	    	glyph_index = FT_Get_Char_Index( face, carac );	          
   		 	error = FT_Load_Glyph( 
              face,          /* handle to face object */
              glyph_index,   /* glyph index           */
              0 );  /* load flags, see below */
				if(error) return 0;                     

			   error = FT_Render_Glyph(
                  slot,      /* glyph slot  */
                  ft_render_mode_normal);    /* render mode */
      
      	if(error) return 0;              

       // now, draw to our target surface
       // inspired from MPlayer font rendering 
	
	FT_Bitmap *bitmap=&(slot->bitmap);
	int heigh;
	int srow=0;
	
		
			heigh=bitmap->rows;
			target+=stride*(size-slot->bitmap_top);
			
	for (int h = heigh; h>0 ; h-- )
	{
							
	    for (int w =0;w< bitmap->width;  w++ )
	    {
				if(bitmap->buffer[srow+w])
			    *(target+w) = bitmap->buffer[srow+w];
		    
		 }  
		 target+=stride;
		 srow+=bitmap->pitch ;		
	}

			*ww=bitmap->width;
			return 1;
} 
#endif
