/***************************************************************************
                          gtk_gui.cpp  -  description
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>


#include <time.h>
#include <sys/time.h>

#include "config.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/filesel.h"
#include "prototype.h"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_toolkit/bitmap.h"
#include "subchunk.h"
#include "avilist.h"




#include "ADM_audio/aviaudio.hxx"
#include "ADM_audio/audioex.h"
#include "ADM_audiofilter/audioprocess.hxx"
#include "gui_action.hxx"
#include "gtkgui.h"
#include "ADM_gui/GUI_vars.h"
#include "ADM_gui/GUI_mux.h"
#include "ADM_gui/GUI_mpeg2enc_opt.h"
#include "oplug_mpeg/op_mpeg.h"
#include "oplug_mpegFF/oplug_vcdff.h"
#include "ADM_audiofilter/audioeng_buildfilters.h"
#include "prefs.h"

extern void videoCodecConfigure( void );

void A_handleSecondTrack(int tracktype);
void A_saveImg(char *name);
void A_loadWave(char *name);
void A_loadAC3(char *name);
void A_saveAudioDecodedTest(char *name);
void A_openBrokenAvi(char *name);
void A_openAvi2(char *name, uint8_t mode);
void A_appendAvi(char *name);
extern void A_SaveAudioNVideo( char *name);
void HandleAction(Action action);
void A_rebuildKeyFrame(void);
extern int GUI_handleFilter(	 void );
extern void filterCleanUp(void);
static void ReSync( void );
static void cleanUp( void );
extern uint8_t getPreviewToggleStatus( void );
extern  void    getPreviewToggleStatus( uint8_t y );
extern void GUI_setName(char *n);
uint8_t GUI_XvInit(GtkWidget *window,uint32_t w,uint32_t h);
uint8_t GUI_XvDisplay(uint8_t *src,uint32_t w ,uint32_t h);
uint8_t  GUI_InitRender (GtkWidget *g, uint32_t w,uint32_t h);
void test_mpeg(char *name);
uint8_t  GUI_getDoubleValue(double *valye, float min, float max, const char *title);
extern void GUI_setMarks(uint32_t a, uint32_t b );
extern void  saveMpegFile(char *name);
//static void A_selectEncoder ( void );
extern void  A_SaveAudioDualAudio(char *name);
static void secondTrackMP3(char *name);
#ifdef USE_AC3
static void secondTrackAC3(char *name);
#endif
static void			updateSecondAudioTrack(void );
extern void 	updateSelectedCodec(Action action);
extern void ADM_switch(Action action);
extern void mpegToIndex(char *name)  ;
static void A_mpegIndexer( void );
extern uint8_t indexMpeg(char *mpeg,char *file,uint8_t aid);
void ADM_cutWizard(void );
void	computeIT(int size,int nb,int brate,uint32_t *frame,uint32_t *rsize);
 void	ADM_saveRaw(char *name );
static void A_saveWorkbench( char *name);
static void A_loadWorkbench( char *name);
void updateLoaded(void );
extern void encoderSetLogFile(char *name);
#define USE_FFMPEG_AS_DEFAULT
#ifdef USE_FFMPEG
//uint8_t 	use_fast_ffmpeg=1;
#ifdef USE_FFMPEG_AS_DEFAULT
uint8_t 	use_fast_ffmpeg=1;
#else
uint8_t 	use_fast_ffmpeg=0;

#endif

#else
uint8_t 	use_fast_ffmpeg=0 ;
#endif

//__________


uint32_t muxSize=0;

extern  int ignore_change ;

PARAM_MUX muxMode=MUX_REGULAR;
int muxParam=0;

extern uint8_t audioShift ;
extern int			audioDelay;

//___________________________________________
// serialization of user event throught gui
//
// Independant from the toolkit used
// QT or other port should be easy
//___________________________________________

void HandleAction(Action action)
{
    uint32_t nf=0;
    
    // handle out of band actions
    // independant load not loaded
//------------------------------------------------				        
    
    switch(action)
    {
    			case ACT_SavePref:
					saveEncoderConfig();
					prefs->save();
				return;
			case ACT_SetLogFile:
			      GUI_FileSelWrite("Select log File to use",encoderSetLogFile);
			      return;
						break;
			case ACT_LoadWork:								
							GUI_FileSelRead("Select workbench to load ",
						       A_loadWorkbench);
			        updateLoaded();
			        return;
							break;						
			case ACT_VideoConfigure:
						printf("\n **\n");
						videoCodecConfigure();
						return;
						break;
     	case  ACT_SetMuxParam:
            setUserMuxParam( (int *)&muxMode, (int *)&muxParam,(int *)&muxSize);
            return;
      			break;
				case ACT_AudioCodecNone:
				case ACT_AudioCodecMP2:
				case ACT_AudioCodecMP3:
				case ACT_AudioCodecAC3:
				  			audioFilter_Update( (int)action);
					
							return;
				case ACT_OuputToggle:
				        guiOutputDisplay^=1;
								return;			
				case ACT_AudioConfigure:
				        audioFilter_Configure();
							return;
							break;
	    			case ACT_MpegIndex:
											A_mpegIndexer(  );
											return;
											break;
				case ACT_SelectDevOSS:
				case ACT_SelectDevDummy:
				case ACT_SelectDevArts:
				                ADM_switch( action);
				                return;
							break;
				case ACT_SelectCodecXvid:
				case ACT_SelectCodecDivx:
				case ACT_SelectCodecFF:
				case ACT_SelectCodecMjpeg:
        			case ACT_SelectCodecFFH263:
        			case ACT_SelectCodecFFH263P:
				case ACT_SelectCodecHuff:
				      		updateSelectedCodec( action);
				        	return;
				        break;
				case ACT_Fast:
						use_fast_ffmpeg=1-use_fast_ffmpeg;
						printf(" Fast FFmpeg is now :%d\n",use_fast_ffmpeg);
						return;
						break;
    case ACT_Exit:
				  	cleanUp();
					  exit(0);
    case ACT_AudioModeProcess:
				  audioProcessMode = 1;
				  return;
	  			break;
    case ACT_AudioModeCopy:
				  audioProcessMode = 0;
				  return;
				  break;
    case ACT_AudioNormalize:
						audioFilter_NormalizeToggle();					  
					  return;
					  break;

      case ACT_AudioReSample:
						audioFilter_ResampleToggle();
					  return;
					  break;
      case ACT_AudioDRC:
					  audioFilter_DRCToggle();
					  return;
					  break;
      case ACT_AudioShift:
					  audioShift ^= 1;
					  if (audioShift)
				    {
							if (!getdelayparameter(&audioDelay))
						    audioShift = 0;
							printf("\n Delay activated for %d ms", audioDelay);
				    }
				    return;
					  break;
     case ACT_VideoModeCopy:
					  videoProcessMode = 0;
					  return;
					  break;
     case ACT_VideoModeProcess:
					  videoProcessMode = 1;
					  return;
					  break;
/*			case ACT_SelectEncoder:
				
						A_selectEncoder();
  	  			return;
						break;*/
				case ACT_SelectEncoder:
						GUI_Alert("Obsolete !");
						break;
												  
		default:	
						break;				        
				        
	}				        
//------------------------------------------------				        
    
    if (playing)		// only allow some action
      {
	  switch (action)
	    {
	    case ACT_PlayAvi:

	    case ACT_StopAvi:
		A_playAvi();
		break;
	    default:
		return;
	    }
      }
    // not playing
    // allow all actions

    // restict disabled uncoded actions
    if ((int) action > 100)
      {
	  GUI_Alert("Not coded on this version");
	  return;

      }
    // allow only if avi loaded
    if (!avifileinfo)
      {
	  switch (action)
	    {
				
						
	    case ACT_OpenAvi:
								GUI_FileSelRead("Select AVI file...", A_openAvi);
		break;

	    case ACT_BrokenAvi:
		printf("\n Opening in broken mode...\n");
		GUI_FileSelRead("Select AVI file...", A_openBrokenAvi);
		break;
		
		
	    default:
		;
	    }
	  return;
      }
   // we have an AVI loaded
    switch (action)
      {
				case ACT_SaveWork:								
							GUI_FileSelWrite("Select workbench to save ",
						       A_saveWorkbench);
							break;						       				
							       				
							
				case ACT_SaveRaw:
						 GUI_FileSelWrite("Select raw file to save ",
						       ADM_saveRaw);
								break;
				case ACT_CutWizard:
								ADM_cutWizard();
								break;
				case ACT_SecondAudioAC3:
#ifdef USE_AC3		
					A_handleSecondTrack(2);
#else
					GUI_Alert("No AC3 support compiled");
#endif
					break;
		case ACT_SecondAudioMP3:
					A_handleSecondTrack(1);
					break;
		case ACT_SecondAudioNONE:
					A_handleSecondTrack(0);
					break;

    case ACT_OpenAvi:
				  GUI_FileSelRead("Select AVI file...", A_openAvi);
				  break;
      case ACT_BrokenAvi:
				  GUI_FileSelRead("Select AVI file...", A_openBrokenAvi);
				  break;
      case ACT_AppendAvi:
				  GUI_FileSelRead("Select AVI file to append...", A_appendAvi);
				  break;
      case ACT_SaveWave:
	  if (currentaudiostream)	// yes it is checked 2 times so what ?
	    {
		if (audioProcessMode)
		  {
		      if (currentaudiostream->isCompressed())
			  if (!currentaudiostream->isDecompressable())
			    {
				GUI_Alert
				    ("Cannot decompress the requested audio stream\nPlease switch to Audio Copy mode");
				break;
			    }
		      // if we get here, either not compressed
		      // or decompressable
		      GUI_FileSelWrite("Select WAV file to save ",
				       A_saveAudioDecodedTest);
		} else		// copy mode...
		  {
		      GUI_FileSelWrite("Select MP3 file to save ",
				       A_saveAudio);
		  }
	    }
	  break;


      case ACT_AviInfo:
	  GUI_ShowAviInfo();
	  break;
      case ACT_Begin:
	  GUI_GoToFrame(0);

	  break;
      case ACT_End:

	  nf = avifileinfo->nb_frames;
	  GUI_GoToFrame(nf - 1);

	  break;

      case ACT_PlayAvi:
	  GUI_PlayAvi();
	  break;

      case ACT_SaveDualAudio:
	  GUI_FileSelWrite("Select AVI to save ", A_SaveAudioDualAudio);
	  break;


      case ACT_SaveImg:
	  GUI_FileSelWrite("Select BMP to save ", A_saveImg);
	  break;
      case ACT_Scale:
      if(!ignore_change)
      {
      	ignore_change++;
			  nf = GUI_GetScale();
			  GUI_GoToKFrame(nf);     			
    	ignore_change--;

    	}
//	  printf("\n new frame : %lu",nf);
	  break;
   		case ACT_PreviewToggle:
     			
     			mode_preview=getPreviewToggleStatus();
     		
        		printf("\n Preview is now : %d",mode_preview);
          		if(mode_preview)
            		{
            			editorReignitPreview();
                		editorUpdatePreview(curframe);

                }
                else
                			editorKillPreview();

     			break;
      case ACT_StopAvi:
	  if (playing)
	      GUI_PlayAvi();
	  break;
      case ACT_SetPostProcessing:
	  			GUI_Alert("Obsolete");
	  break;

      case ACT_NextFrame:
	  GUI_NextFrame();
	  break;
      case ACT_NextKFrame:
	  GUI_NextKeyFrame();
	  break;
      case ACT_PreviousFrame:
	  if (curframe)
	    {
		GUI_Working();
		GUI_GoToFrame(curframe - 1);
		GUI_StopWorking();

	    }

	  break;

	  case ACT_Forward50Frames:
	  	GUI_GoToFrame(curframe + 50);
	  break;
	  
	  case ACT_Forward25Frames:
	  	GUI_GoToFrame(curframe + 25);
	  break;
	  
	  case ACT_Back50Frames:
	  if (curframe>=50)
	    {
		GUI_Working();
	  	GUI_GoToFrame(curframe - 50);
		GUI_StopWorking();
	    }
	  break;
	  
	  case ACT_Back25Frames:
	  if (curframe>=25)
	    {
		GUI_Working();
	  	GUI_GoToFrame(curframe - 25);
		GUI_StopWorking();
	    }
	  break;

      case ACT_PreviousKFrame:
	  GUI_PreviousKeyFrame();
	  break;
      case ACT_AudioSourceAvi:
	  //currentaudiostream=aviaudiostream;
	  changeAudioStream(aviaudiostream, AudioAvi);
	  //wavinfo= currentaudiostream->getInfo();
	  break;

      case ACT_AudioSourceMP3:
	  GUI_FileSelRead("Select MP3 to load ", GUI_loadMP3);
	  break;
		case    ACT_AudioSourceAC3:
#ifndef USE_AC3
             	GUI_Alert("AC3 Not enabled at compilation time !");
#else
  				  GUI_FileSelRead("Select AC3 to load ", A_loadAC3);
#endif                                 
  		break;
      case ACT_AudioSourceWAV:
	  GUI_FileSelRead("Select WAV to load ", A_loadWave);
	  break;
      case ACT_AudioSourceNone:
	  //currentaudiostream=(AVDMGenericAudioStream *)NULL;
	  changeAudioStream((AVDMGenericAudioStream *) NULL, AudioNone);
	  break;
      case ACT_FrameChanged:
//	  GUI_GoToGUI(0);
	  break;
      case ACT_TimeChanged:
//	  GUI_GoToGUI(1);
	  break;
      case ACT_MarkA:
      case ACT_MarkB:

	  if (action == ACT_MarkA)
	      frameStart = curframe;
	  else
	      frameEnd = curframe;
	  if (frameStart > frameEnd)	// auto swap
	    {
		uint32_t y;
		y = frameStart;
		frameStart = frameEnd;
		frameEnd = y;
	    }
	  GUI_setMarks(frameStart,frameEnd);
	  break;
      case ACT_GotoMarkA:
      case ACT_GotoMarkB:

	  if (action == ACT_GotoMarkA)
	      nf = frameStart;
	  else
	      nf = frameEnd;
	  GUI_GoToFrame(nf);
	  break;
      case ACT_Goto:
	  uint32_t fn;
	  if (getFramenum(&fn))
	    {
	    if(fn)
	    { // 0 probably means garbage
		if (fn < avifileinfo->nb_frames)
		  {
		      curframe = fn;
		      GUI_GoToFrame(curframe);
		} else
		    GUI_Alert("Out of bounds!");
	    }
	    }
	  break;
//----------------------test-----------------------
   	case ACT_SaveAvi:
                GUI_FileSelWrite("Select AVI file to save ",
			       			A_SaveAudioNVideo);
    	break;
//---------------------------------------------------
      case ACT_Copy:
      case ACT_Paste:
	  GUI_Alert("Not available yet");
	  break;
      case ACT_Delete:
      	uint32_t count;
	aviInfo info;
	assert(video_body->getVideoInfo(&info));  			
		count=frameEnd-frameStart;
		if(count>=info.nb_frames-1)
		{
			GUI_Alert("You don't want to \n remove all frames !");
			return;
		
		}
	
	  video_body->dumpSeg();
	  if (!video_body->removeFrames(frameStart, frameEnd))
	    {
		GUI_Alert("Something bad happened...");
	    }
	  video_body->dumpSeg();
	  //resync GUI and video
	  if (!video_body->updateVideoInfo(avifileinfo))
	    {
		GUI_Alert("Something bad happened (II)...");
	    }
     if(frameStart>=avifileinfo->nb_frames)
     	{  	// we removed too much
      		   	
           	frameStart=  avifileinfo->nb_frames-1;
        }
	  GUI_GoToFrame(frameStart);
	  update_status_bar(1);
	  ReSync();
	  break;
		
   	  case ACT_AudioMap:
      		printf("\n making audio timeline\n");
      		if(currentaudiostream)
        		{
            		
               currentaudiostream->  buildAudioTimeLine();

            	}
        		break;

	case   ACT_ChangeFPS:
 			double fps;
    		if(GUI_getDoubleValue(&fps,1.,60.,"New FPS ?"))
      			{
			           aviInfo info;
                      		video_body->getVideoInfo(&info);
                        		info.fps1000=(uint32_t)(floor(fps*1000.));
								video_body->updateVideoInfo(&info);                          	
        			           // update display
							    video_body->getVideoInfo(avifileinfo);



           	}
              break;
              // set decoder option (post processing ...)
      case ACT_DecoderOption:
                     		video_body->setDecodeParam();
      					
      			break;
   
         case ACT_XVCD:

#ifdef USE_FFMPEG
                   GUI_FileSelWrite("Select mpeg1video file to save ",
				       oplug_mpegff);
          				break;
#endif				

      case ACT_SaveMpeg1vcd:
#ifdef USE_MJPEG			
         GUI_FileSelWrite("Select mpeg1video file to save ", oplug_mpeg_vcd);
#else
         GUI_Alert("\n not compiled with mpeg \noutput support");
#endif
         break;

      case ACT_SaveMpeg2svcd:
#ifdef USE_MJPEG			
//         if( GUI_Mpeg2enc_opts("SVCD"))
	         GUI_FileSelWrite("Select mpeg2video file to save ", oplug_mpeg_svcd);
#else
         GUI_Alert("\n not compiled with mpeg \noutput support");
#endif
         break;

      case ACT_SaveMpeg2dvd:
#ifdef USE_MJPEG			
   //      if( GUI_Mpeg2enc_opts("DVD"))
	         GUI_FileSelWrite("Select mpeg2video file to save ", oplug_mpeg_dvd);
#else
         GUI_Alert("\n not compiled with mpeg \noutput support");
#endif
         break;

	  case ACT_VideoParameter:
	   	// first remove current viewer
 			if(mode_preview)
  		    	  	editorKillPreview();
	  		GUI_handleFilter();
      		if(mode_preview)
	      		editorUpdatePreview(curframe);
	  		break;

     	  case ACT_RebuildKF:
		  if (GUI_Question("Rebuild all Keyframes?"))
    		{
	      		A_rebuildKeyFrame();
         		GUI_Alert("Save your file and restart Avidemux!");
         	}
           break;

      default:
      printf("\n unhandled action %d\n",action);
	  assert(0);
	  return;

      }
      
      
     // gtk_widget_grab_focus(sb_frame);
}

#ifdef USE_MJPEG
#include "oplug_mpeg/op_mpeg.h"

void A_saveMpeg(char *name)
{
		
			oplug_mpeg_vcd(name); 	

}


#endif

//_____________________________________________________________
//
// Open AVI File
//    mode 0: normal
//    mode 1: Suspicious
//_____________________________________________________________

void A_openBrokenAvi(char *name)
{
    A_openAvi2(name, 1);
}
void A_openAvi(char *name)
{
    A_openAvi2(name, 0);
}
extern void GUI_PreviewEnd( void );
void A_openAvi2(char *name, uint8_t mode)
{
    uint8_t  res;

    if (playing)
	return;
    /// check if name exists
    FILE *fd;
    fd = fopen(name, "rb");
    if (!fd)
	return;
    fclose(fd);

    if (avifileinfo)		// already opened ?
      {				// delete everything
      // if preview is on
      if(mode_preview)
		      GUI_PreviewEnd();
	         delete avifileinfo;
	  //delete wavinfo;
	  wavinfo = (WAVHeader *) NULL;
	  avifileinfo = (aviInfo *) NULL;
	  video_body->cleanup();
	  curframe = 0;
	  currentaudiostream = NULL;
	  changeAudioStream(NULL, AudioNone);
	   filterCleanUp();
	  if (screen_buffer)
	    {
		free(screen_buffer);
		screen_buffer = NULL;
	    }
	
         if (rdr_decomp_buffer)
	    {
		free(rdr_decomp_buffer);
		rdr_decomp_buffer = NULL;
	    }

      }
    GUI_Working();
    if (mode)
	res = video_body->addFile(name, 1);
    else
	res = video_body->addFile(name);
	GUI_StopWorking();
    if (!res)			// an error occured
      {
	  currentaudiostream = NULL;
	  avifileinfo = NULL;
	 
	  GUI_Alert("Problem opening that file!");
	  return;
	  }
	  updateLoaded();

}
		
void updateLoaded()
{      
	  if(avifileinfo)
	  	{
			 	delete avifileinfo;
			  avifileinfo=NULL;
			}
    avifileinfo = new aviInfo;
    if (!video_body->getVideoInfo(avifileinfo))
      {
//	err1:
		printf("\n get info failed...cancelling load...\n");
	  delete avifileinfo;
	  avifileinfo = (aviInfo *) NULL;
	  currentaudiostream = aviaudiostream = NULL;
	

	  return;

    } 
	  update_status_bar(1);
		curframe = 0;
	
		assert(screen_buffer = (uint8_t *)   malloc(4 * avifileinfo->width *    avifileinfo->height));	
   	assert(rdr_decomp_buffer =   (uint8_t *) malloc(4 * avifileinfo->width *  avifileinfo->height));

	  frameStart = 0;
	  frameEnd = avifileinfo->nb_frames - 1;
	  GUI_setMarks(frameStart, frameEnd );
     
    // now get audio information if exists
    wavinfo = video_body->getAudioInfo();	//wavinfo); // will be null if no audio
    if (!wavinfo)
      {
	  			printf("\n *** NO AUDIO ***\n");
	  			wavinfo = (WAVHeader *) NULL;
	  			currentaudiostream = aviaudiostream =  (AVDMGenericAudioStream *) NULL;
    } else
      {
	  		video_body->getAudioStream(&aviaudiostream);
	  		changeAudioStream(aviaudiostream, AudioAvi);
   	 		if(  aviaudiostream)
     		if(!aviaudiostream->isDecompressable())
	  			{
				GUI_Alert("Beware: No valid audio codec found!\n"
			  		"Save(A+V) will generate bad AVI\nSave audio will work");
	  			}	

     }
   
    // Init renderer
    GUI_InitRender(drawingarea1, avifileinfo->width, avifileinfo->height);
    curframe = 0;
    update_status_bar(1);

    // Draw first frame
		if (!video_body->getUncompressedFrame(curframe, rdr_decomp_buffer))
		  {
		    	GUI_Alert("Problem decompressing frame!");
    		}
      else
      	GUI_Display();

}

//___________________________________________
//  Append an AVI to the existing one
//___________________________________________
void A_appendAvi(char *name)
{


    if (playing)
	return;
     GUI_Working();
    if (!video_body->addFile(name))
      {
	  GUI_StopWorking();
	  GUI_Alert("Something failed ...");
	  return;
      }
	  GUI_StopWorking();


    video_body->dumpSeg();
    if (!video_body->updateVideoInfo(avifileinfo))
      {
	  GUI_Alert("Something bad happened (II)...");
      }
 	
  		ReSync();

}
//
//	Whenever a changed happened in the the stream, resync
//  related infos including audio & video filters

void ReSync( void )
{
uint8_t isaviaud;

		frameStart = 0;
    frameEnd = avifileinfo->nb_frames - 1;
    // update audio stream
    // If we were on avi , mark it...
		if(currentaudiostream==aviaudiostream)
		{
				 	 isaviaud=1;
				 	 changeAudioStream((AVDMGenericAudioStream *) NULL, AudioNone);
				 	
		}
			else
					isaviaud=0;
    update_status_bar(1);

    // Since we modified avi stream, rebuild audio stream accordingly
    video_body->getAudioStream(&aviaudiostream);
    if( isaviaud)
    {
     	  	  changeAudioStream(aviaudiostream, AudioAvi);
    }
    updateVideoFilters();
}

//_____________________________________________________________
//    Save current stream (generally avi...)
//     in raw mode
//_____________________________________________________________
void A_saveAudio(char *name)
{

// debug audio seek
    uint32_t len2;
    uint32_t written, max;
    FILE *out;

#define BITT 500
    uint8_t buffer[BITT];

    if (!currentaudiostream)
	return;
 	if(!currentaudiostream->isCompressed())
  	{
      	GUI_Alert("The audio is wav PCM. \nPlease select Audio Process mode \notherwise the audio stream will be\n unreadable (raw PCM))");
		return;
     }

    GUI_Working();
    out = fopen(name, "wb");
    assert(out);

// compute start position
    currentaudiostream->goToTime(video_body->getTime(frameStart));
// compute max bytes to write (with little margin)
    max =
	currentaudiostream->convTime2Offset(video_body->
					    getTime(frameEnd + 1)) -
	currentaudiostream->convTime2Offset(video_body->
					    getTime(frameStart));
    written = 0;
    while (1)
      {
	  len2 = currentaudiostream->read(BITT, (uint8_t *) buffer);
	  fwrite(buffer, len2, 1, out);
	  if (len2 != BITT)
	      break;
	  written += len2;
	  if (written > max)
	      break;		// we wrote everything !

	  GUI_UpdateWorking(written, max);
      };
    fclose(out);
    GUI_StopWorking();
    printf("\n wanted %lu bytes, written %lu\n", max, written);


}


//extern void yuv2rgb(uint8_t *ptr,uint8_t *ptr2,uint32_t w,uint32_t h);

//____________________________________________________________
//
//      Play AVI  + Audio if possible
//_____________________________________________________________
void A_playAvi(void)
{

}

//________________________________________________________
// Save a BMP image from current buffer
//________________________________________________________

void A_saveImg(char *name)
{
    BITMAPFILEHEADER bmfh;
    BITMAPHEADER bmph;
    FILE *fd;
    uint32_t sz;
    uint16_t s16;
    uint32_t s32;

    fd = fopen(name, "wb");
    if (!fd)
      {
	  GUI_Alert("Something bad happened.");
	  return;
      }
// Bitmpap file header, not using tructure due to gcc padding it
    s16 = 0x4D42;
    s32 = 14 + sizeof(bmph) + 3 * avifileinfo->width * avifileinfo->height;
    fwrite(&s16, 2, 1, fd);
    fwrite(&s32, 4, 1, fd);
    s32 = 0;
    fwrite(&s32, 4, 1, fd);
    s32 = 14 + sizeof(bmph);
    fwrite(&s32, 4, 1, fd);


    printf("\n Size : %lX\n", bmfh.size);
    bmfh.xHotspot = bmfh.yHotspot = 0;
    bmfh.offsetToBits = sizeof(bmfh) + sizeof(bmph);
//_________________________________________
    bmph.size = sizeof(bmph);
    bmph.width = avifileinfo->width;
    bmph.height = avifileinfo->height;
    bmph.numBitPlanes = 1;
    bmph.numBitsPerPlane = 24;
    bmph.compressionScheme = 0;	// COMPRESSION NONE
    bmph.sizeOfImageData = bmph.width * bmph.height * 3;
    bmph.xResolution = 0;
    bmph.yResolution = 0;
    bmph.numColorsUsed = 0;
    bmph.numImportantColors = 0;
/*
	bmph.resolutionUnits=0;
	bmph.origin=0;
	bmph.colorEncoding=0;
*/
    sz = bmph.width * bmph.height * 3;


    printf("\n %lu x %lu=%lu\n", bmph.width, bmph.height, sz);


    // YUYV 2 RGV
    GUI_ConvertRGB(rdr_decomp_buffer, screen_buffer,
		   bmph.width, bmph.height);


    fwrite(&bmph, sizeof(bmph), 1, fd);
    // invert screen buffer + swap y
    uint8_t *e;
    uint32_t w, y;
    uint8_t buff[800 * 3];

    w = bmph.width * 3;
    e = screen_buffer;
    e += w * (bmph.height - 1);


    y = (uint32_t) bmph.height;
    for (; y > 0; y--)
      {
	  //
	  memcpy(buff, e, w);
	  swapRnB(buff, bmph.width);
	  fwrite(buff, w, 1, fd);
	  e -= w;
      }



    GUI_Alert("Done.");



    fclose(fd);
}
//_____________________________________________________________
//
//              Load AC3
//
//
//_____________________________________________________________
void A_loadAC3(char *name)
{
    if (!avifileinfo)
	return;

#ifdef USE_AC3
    AVDMAC3AudioStream *ac3 = new AVDMAC3AudioStream();

    if (ac3->open(name) == 0)
      {
        GUI_Alert("Failed to open this file \n (Not a WAV file?)\n");
	  printf("WAV open file failed...");
	  delete ac3;   	    	
	  return;
      }
    //currentaudiostream=wav;
    changeAudioStream(ac3, AudioAC3);
    wavinfo = currentaudiostream->getInfo();
#else
    fprintf(stderr,"A_loadAC3(%s) not implemented. Install liba52 and rebuild avidemux.\n",(name ? name : "NULL"));
#endif
}

//_____________________________________________________________
//
//              Load wave
//              
//
//_____________________________________________________________
void A_loadWave(char *name)
{
    if (!avifileinfo)
	return;
    AVDMWavAudioStream *wav = new AVDMWavAudioStream();

    if (wav->open(name) == 0)
      {
        GUI_Alert("Failed to open this file \n (Not a WAV?)\n");
	  printf("WAV open file failed...");
	  delete wav;   	    	
	  return;
      }
    //currentaudiostream=wav;
    changeAudioStream(wav, AudioWav);
    wavinfo = currentaudiostream->getInfo();
}

//________________________________________________________
// Change audio stream and delete the old one if needed
//________________________________________________________
void changeAudioStream(AVDMGenericAudioStream * newaudio,
		       AudioSource nwsource)
{
    if (currentaudiostream)
      {
	  if (currentaudiostream->isDestroyable())
	      delete currentaudiostream;
      }
    currentaudiostream = newaudio;
    GUI_UpdateAudioToggle(nwsource);
    if (currentaudiostream)
	wavinfo = currentaudiostream->getInfo();

}

//_____________________________________________________________
//    Save current stream (generally avi...)
//     in decoded mode (assuming MP3)
//_____________________________________________________________
void A_saveAudioDecodedTest(char *name)
{

// debug audio seek
    uint32_t len2, gauge = 0;
    uint32_t written = 0, max;
    FILE *out;
    AVDMGenericAudioStream *saveFilter;
#undef BITT
#define BITT 4*1152
#define OUTCHUNK 1024*1024
    uint8_t *outbuffer;

    if (!currentaudiostream)
	return;
    if (currentaudiostream->isCompressed())
	if (!currentaudiostream->isDecompressable())
	  {
	      GUI_Alert("Cannot decompress audio frame!");
	      return;
	  }


    if (!(out = fopen(name, "wb")))
      {
	  GUI_Alert("Cannot write file");
	  return;
      }

    outbuffer = (uint8_t *) malloc(2 * OUTCHUNK);	// 1Meg cache;
    if (!outbuffer)
      {
	  GUI_Alert("Memory Error!");
	  return;
      }
// compute max bytes to read (with little margin)
    max =
	video_body->getTime(frameEnd + 1) -
	video_body->getTime(frameStart);
    //convert time in ms to bytes

    double db;
    db = max;
    // 01/10/2002 Fix for 5.1->stereo conversion
    if(wavinfo->channels>2)
    		db *= 2;
		else    
	    db *= wavinfo->channels;
    db *= wavinfo->frequency;
    db /= 500;			// 1000 because ms, 2 bytes / sample
    max = (uint32_t) floor(db);

    printf("\n input : %lu bytes\n", max);


// re-ignite first filter...

    currentaudiostream->beginDecompress();


    // Write Wav header

    /* Sat Nov 09 06:11:52 CET 2002 Fixes from Maik Broemme <mbroemme@plusserver.de> */
    /* If you set negative delay and save the audio stream, the saved stream was shorter than the video stream. */

    /* Example: video stream is 10 minutes long, audio stream perhaps 20 minutes, you need the audio stream from */
    /*          minute 1 until 11, so you setup an audio delay from -60 seconds, but this 60 seconds were removed */
    /*          from begin and end of the audio stream. That was not good :) Now it runs correctly also if you use */
    /*          audio stream with same length then video, therefore is premature ending :) */

    uint32_t  delay = 0;
    if (audioDelay > 0) {
        saveFilter = buildAudioFilter(currentaudiostream,video_body->getTime(frameStart), max, 1);
    }
    else {
        delay = currentaudiostream->convTime2Offset(-audioDelay);
        saveFilter = buildAudioFilter(currentaudiostream,video_body->getTime(frameStart), max + delay, 1);
    }
    GUI_Working();

//
//  Create First filter that is null filter
//



    saveFilter->writeHeader(out);
    printf(".. Starting ..\n");
    if (audioDelay > 0) {
        max = saveFilter->getLength();
    }
    else {
        max = saveFilter->getLength() - delay;
    }
    printf("\n Computed length : %lu\n", max);
    while (1)
      {
	  len2 = saveFilter->readDecompress(BITT, outbuffer + gauge);
	  //      printf("Got : %lu\n",len2);
	  gauge += len2;
	  if ((len2 == 0) || (gauge > OUTCHUNK))	// either out buffer is full
	      // or we read nothing -> end of file
	    {
		fwrite(outbuffer, 1, gauge, out);
		//      fflush(out);    
		written += gauge;
		gauge = 0;
		if (len2 == 0)
		    break;	// premature ending
		// update GUI                   
		if (GUI_UpdateWorking(written, max))	// abort request ?
		    goto abortSaveAudio;
		//printf("\n written %lu/%lu max\n",written,max);
	    }
	  //      if(written>max) break; // we wrote everything !
      };
  abortSaveAudio:
    saveFilter->endWrite(out, written);
    fclose(out);
    free(outbuffer);
    GUI_StopWorking();
    deleteAudioFilter();
    currentaudiostream->endDecompress();
    printf(" actually written %lu\n", written);


}




//	Clean up
//	free all pending stuff, make leakchecker happy
//
void cleanUp( void )
{
	if(avifileinfo) delete avifileinfo;
	if(currentaudiostream) 
	{
	// always destroyable on exit		if(currentaudiostream->isDestroyable())
		delete currentaudiostream;
	}
	if(video_body) delete video_body;
	//
	filterCleanUp();
	

}
extern uint8_t selecEncoder( uint8_t *codec);


/*void A_selectEncoder ( void )
{
		
       selecEncoder( &codec_in_use );
} */
/*
  		0-> None
    	1->	MP3
     	2-> AC3

*/
void 		A_handleSecondTrack(int tracktype)
{
		/* lock which one is selected in GUI */
				


		switch(tracktype)
				{
					
						case 0:
										if(secondaudiostream)
													{
															delete secondaudiostream;
															secondaudiostream=NULL;
															printf("\n second audio stream destroyed\n");	
													}	
													updateSecondAudioTrack();	

											break;
						case 1: // MP3
										if(  secondaudiostream && secondaudiostream_isac3==0) return;
										if(secondaudiostream)
													{
															delete secondaudiostream;
															secondaudiostream=NULL;
															printf("\n second audio stream destroyed\n");	
													}	
											
												secondaudiostream_isac3=0;
												GUI_FileSelRead("Select MP3",secondTrackMP3);
											break;
#ifdef USE_AC3										
						case 2: // AC3
									if(  secondaudiostream && secondaudiostream_isac3==1) return;

										if(secondaudiostream)
													{
															delete secondaudiostream;
															secondaudiostream=NULL;
															printf("\n second audio stream destroyed\n");	
													}	
											
												secondaudiostream_isac3=1;
												GUI_FileSelRead("Select AC3",secondTrackAC3);
											break;
#endif
											
												
				}	
	
}

#ifdef USE_AC3
void secondTrackAC3(char *name)
{
		AVDMAC3AudioStream *tmp;
		
			tmp=new AVDMAC3AudioStream();
			if(!tmp->open(name))
					{
							delete tmp;
							printf("\n Cancelled AC3 load\n");	
					}	
			else
			{
				  secondaudiostream=tmp;
				  secondaudiostream_isac3=1;
					printf("\n AC3 loaded\n");					
			}
			updateSecondAudioTrack();	
}
#endif	

void secondTrackMP3(char *name)
{
		AVDMMP3AudioStream *tmp;
		
			tmp=new AVDMMP3AudioStream();
			if(!tmp->open(name))
					{
							delete tmp;
							printf("\n Cancelled MP3 load\n");	
					}	
			else
			{
				  secondaudiostream=tmp;
				  secondaudiostream_isac3=0;
					printf("\n MP3 loaded\n");					
			}
			updateSecondAudioTrack();	
	
}
void			updateSecondAudioTrack(void )
{
return;   
//#define GOGLE(x,y) gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (x), y)
#define GOGLE(x,y) {gtk_check_menu_item_set_show_toggle (GTK_CHECK_MENU_ITEM (x), y);}
 

	if(!secondaudiostream) 
	{
			GOGLE(second_track_none,TRUE) ;						
			GOGLE(second_track_ac3,FALSE) ;
			GOGLE(second_track_mp3,FALSE) ;

	}
	else
			{
				GOGLE(second_track_none,FALSE) ;						
				
				if( secondaudiostream_isac3)
				{
						GOGLE(second_track_ac3,TRUE) ;
						GOGLE(second_track_mp3,FALSE) ;

				}
				else
				{
						GOGLE(second_track_ac3,FALSE) ;
						GOGLE(second_track_mp3,TRUE) ;
				}
			}
}	

extern void getCutPoints( int br);
void ADM_cutWizard(void )
{
	
		int br;
			if(currentaudiostream)
				{
					br=currentaudiostream->getInfo()->byterate*8/1000;	
				}
				else
					br=128;
	
	  getCutPoints(br);
	
}
void	computeIT(int size,int nb,int brate,uint32_t *frame,uint32_t *rsize)
{
	   uint32_t curframe,cursize;
	   uint32_t lastframe,lastsize;
	   uint32_t lsize=size;
	   curframe=cursize=lastframe=lastsize=0;
	   uint32_t one_audio;

//		 uint8_t tmp[768*768*3];	   
//		 uint32_t len2;
		 uint32_t len,flag;
		 
		 uint8_t ret;
	   
	        lastframe=frameStart;
//
		double fi=brate>>3;							            
		fi=fi/avifileinfo->fps1000;
		fi*=1000000.;
		one_audio=(uint32_t )floor(fi);
	                    	                   	
	           printf("\n search for %lu\n",lsize); 
	           printf("\n one audio  %lu\n",one_audio);   
	   for(uint32_t f=frameStart;f<	  avifileinfo->nb_frames;f++)
	   	{
				
			cursize+=32+32+2*32*nb; // index + header
			cursize+=one_audio*nb;
			len=0;			
			ret=video_body->getFrameSize(f,&len);			 								
			video_body->getFlags(f,&flag);
			if(!ret)
			{
			 	printf("\n Error!\n");
				*frame=lastframe;
				*rsize=lastsize;
			  	return;
			}
			cursize+=len;
			// check if we went beyonf
			if(cursize>lsize)
			{
				*frame=lastframe;
				*rsize=lastsize;
			         printf("\n found : Frame %lu  %lu\n",lastframe,lastsize);   
				return;									
			}							
			// if it is a key f we memorize it
			if(flag & AVI_KEY_FRAME)
				{
						lastframe=f;
						lastsize=size;
				}
			}

	   
	   printf("\n oops\n");
	   *rsize=0;
	   *frame=0;
}
extern int  GUI_mpegIndexer(char **mpegFile,char **indexFile,int *aid,int already=0);

//________________________________
void A_mpegIndexer( void )
{
char *mpeg,*file;
int id;
     if(GUI_mpegIndexer(&mpeg,&file,&id))
     {
			 if((mpeg==NULL ) || (file==NULL))
			 {
				 	GUI_Alert("Please select at least one file to process!");
				  return;
				}
			 printf("\n indexing :%s to \n%s\n",mpeg,file);
				if(indexMpeg(mpeg,file,(uint8_t ) id))
					GUI_Alert("Index done");	 
			 
		}
		else
		{
			printf("\n cancelled\n");	
		}
}
void	ADM_saveRaw(char *name )
{
uint32_t len,flags;
FILE *fd,*fi;
uint8_t *buffer=new uint8_t[avifileinfo->width*
											      avifileinfo->height*3]; 
char *idx;
											      
	idx=new char[strlen(name)+8];										      
	strcpy(idx,name);
	strcat(idx,".idx");
	fd=fopen(name,"wb");											      
	fi=fopen(idx,"wt");											      
	if(!fd) return;
	GUI_Working();    // GUI_Working
	// preamble
	video_body->getRawStart(frameStart,buffer,&len);
	fwrite(buffer,len,1,fd);	
	
	for(uint32_t i=frameStart;i<frameEnd;i++)
	{
			GUI_UpdateWorking(i-frameStart,frameEnd-frameStart);

			assert(video_body->getFlags(i,&flags));
			if(flags & AVI_B_FRAME) // oops
			{
				// se search for the next i /p
				uint32_t found=0;
				
				for(uint32_t j=i+1;j<frameEnd;j++)
						{
							assert(video_body->getFlags(j,&flags));
							if(!(flags & AVI_B_FRAME))
							{
								found=j;
								break;
							}
						
						}
				if(!found) goto _abt;
				// Write the found frame
				video_body->getRaw(found,buffer,&len);
				fwrite(buffer,len,1,fd);	
				// and the B frames
				for(uint32_t j=i;j<found;j++)
				{
					video_body->getRaw(j,buffer,&len);
					fwrite(buffer,len,1,fd);					
				}
				i=found; // Will be plussed by for
			}
			else  // P or I frame
			{
				video_body->getRaw(i,buffer,&len);
				fwrite(buffer,len,1,fd);			
				fprintf(fi,"%lu,\n",len);			
			}
			
	}	
_abt:	
	fclose(fd);
	fclose(fi);
	GUI_StopWorking();
	
}
void A_saveWorkbench( char *name)
{
		video_body->saveWorbench(name);
}
void A_loadWorkbench( char *name)
{
		video_body->loadWorbench(name);
}

// EOF
