/***************************************************************************
                          gui_navigate.cpp  -  description
                             -------------------

            GUI Part of get next frame, previous key frame, any frame etc...

    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/filesel.h"
#include "prototype.h"
#include "ADM_audiodevice/audio_out.h"
#include "ADM_audio/aviaudio.hxx"
#include "ADM_audiofilter/audioprocess.hxx"
#include "gui_action.hxx"
#include "gtkgui.h"
#include "gui_action.hxx"
#include "ADM_toolkit/toolkit.hxx"

//____________________________________

void GUI_NextFrame(void)
{
//    uint8_t *ptr;

    if (playing)
	return;

    if (avifileinfo)
      {
        if( !video_body->getUncompressedFrame(curframe + 1,rdr_decomp_buffer))
        	{
            	GUI_Alert("Decompressing Error NF");
           }
           else
           {
					curframe++;
                   if(mode_preview)
          				editorUpdatePreview( curframe) ;

			    	GUI_Display();
     		       update_status_bar();

	  		}
     }
}


//_____________________________________________________________
void GUI_NextKeyFrame(void)
{

    uint32_t f;


    if (playing)
		return;

   f=curframe;
    if (avifileinfo)
      {
		  if( !video_body->getUncompressedFrameNKF(&f ,rdr_decomp_buffer))
        	{
            //	GUI_Alert("Decompressing Error");
           }
           else
           {
             	curframe=f;

			    GUI_Display();
              if(mode_preview)
         				editorUpdatePreview( curframe)     ;

		       update_status_bar();
	  		}
		
	  }

}


//
// Go to the neareste frame near frame
// we take the previous one to simplify
//_____________________________________________________________
void GUI_GoToKFrame(uint32_t frame)
{
   uint32_t old=curframe;

        if (playing)
				return;

       if (avifileinfo)
      {
       // curframe=frame;
       //
     	curframe=frame;
	      if( !video_body->getUncompressedFramePKF(&curframe ,rdr_decomp_buffer))
        	{
           	curframe=old;
            	GUI_Alert("Decompressing Error KF");
           }
           else
           {             	
                	GUI_Display();
                               if(mode_preview)
          				editorUpdatePreview( curframe)   ;

             		update_status_bar(0);	  	
	  		}
     }
}

//_____________________________________________________________
void GUI_GoToFrame(uint32_t frame)
{


    if (playing)
	return;

       if (avifileinfo)
      {

        	if( !video_body->getUncompressedFrame(frame ,rdr_decomp_buffer))
        	{
            	GUI_Alert("Decompressing Error GF");
           }
           else
           {
              curframe = frame;
   			    GUI_Display();

                            if(mode_preview)
          				editorUpdatePreview( curframe)       ;

              update_status_bar();
	  	
	  		}
     }
    update_status_bar(0);

}



void GUI_PreviousKeyFrame(void)
{

    uint32_t f;


    if (playing)
	return;

    f=curframe;
    if (avifileinfo)
      {
		  if( !video_body->getUncompressedFramePKF(&f ,rdr_decomp_buffer))
        	{
            	//GUI_Alert("Decompressing Error");
           }
           else
           {
             	curframe=f;
   			    GUI_Display();

              if(mode_preview)
          				editorUpdatePreview( curframe);
              update_status_bar();
	  	
	  		}
		 }
};

