/***************************************************************************
                          gui_render.cpp  -  description

	This final render a frame. The external interface is the same
	whatever the mean (RGB/YUV/Xv)
                             -------------------
    begin                : Thu Jan 3 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>         
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

//#include <gdk-pixbuf-1.0/gdk-pixbuf/gdk-pixbuf.h>

/*#include <gtk-2.0/gdk-pixbuf/gdk-pixbuf.h>
#include <gtk-2.0/gdk-pixbuf-xlib/gdk-pixbuf-xlib.h>
   */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>

#include "avi_vars.h"
#include "prototype.h"
#include "ADM_colorspace/colorspace.h"

#include "ADM_gui/GUI_vars.h"

uint8_t GUI_XvInit(GtkWidget *window,uint32_t w,uint32_t h);
uint8_t GUI_XvDisplay(uint8_t *src,uint32_t w ,uint32_t h);
uint8_t  GUI_InitRender (GtkWidget *g, uint32_t w,uint32_t h);
extern uint8_t GUI_Display(uint8_t *buf=NULL,uint32_t w=0,uint32_t h=0);
extern void GUI_XvEnd( void );
extern void yuv420_argb32_mmx (uint8_t * image, uint8_t * py,
			       uint8_t * pu, uint8_t * pv,
			       int h_size, int v_size);
// memorize size of display for later

// static uint8_t slowYV12RGB(uint8_t * ptr_y, uint8_t * ptr_u,
// 			   uint8_t * ptr_v, uint8_t * ptr2, uint32_t w);
#ifndef COLORSPACE_YV12
static uint8_t slowYUYV2RGB(uint8_t * ptr_y,
			    uint8_t * ptr_u,
			    uint8_t * ptr_v, uint8_t * ptr2, uint32_t w);
static void yuv2rgb(uint8_t * ptr, uint8_t * ptr2, uint32_t w, uint32_t h);
#endif
static uint8_t xv_mode;
//_______________________________________
static uint32_t Rw, Rh;
static uint8_t _XvAvailable = 0;
//
/*extern uint8_t *rdr_decomp_buffer;
extern uint8_t *screen_buffer;
*/
//----------------------------------------
uint8_t GUI_InitRender(GtkWidget * win, uint32_t w, uint32_t h)
{
    Rw = w;
    Rh = h;

/*	gtk_window_set_policy(win->window,
																				TRUE,TRUE,TRUE);	
gtk_window_set_policy(window1->window,
																				TRUE,TRUE,TRUE);	*/
     gtk_widget_set_usize(win, -1, -1);
    gtk_widget_set_usize(win, w, h);
        gdk_window_move_resize(win->window,
                            0 ,         0,
                            w, h);




    return 1;
}

uint8_t GUI_ConvertRGB(uint8_t * in, uint8_t * out, uint32_t w, uint32_t h)
{
#ifdef COLORSPACE_YV12

	        yv12rgb(in, out, w, h);

#else
    		yuv2rgb(in, out, w, h);
#endif
    return 1;
}

//
//_______________________________________________
uint8_t GUI_Refresh(void)
{
#ifdef USE_XV
    if (_XvAvailable && xv_mode)
	GUI_XvDisplay(rdr_decomp_buffer, Rw, Rh);
    else
#endif
	GUI_RGBDisplay(screen_buffer, Rw, Rh,drawingarea1);
    return 1;
}


uint8_t GUI_SwitchToXv( uint32_t w, uint32_t h)
{

#ifdef USE_XV
GtkWidget *win=GTK_WIDGET(drawingarea1);
    _XvAvailable = GUI_XvInit(win, w, h);

    if (_XvAvailable)
    {
		printf("\n Xv Available...using it\n");
  		xv_mode=1;
    }
#endif
 return 1;
 }
void GUI_SwitchToRGB( uint32_t w,uint32_t h )
{
        UNUSED_ARG(w);
	UNUSED_ARG(h);
#ifdef USE_XV
	if(xv_mode)
 	{
     	// Kill Xv
         // GUI_Display();
          GUI_XvEnd();
          GUI_XvInit(GTK_WIDGET(drawingarea1), 16, 16);

    }
#endif
	printf("\n Back to RGB\n");

 	xv_mode=0;
   GUI_Display();
}
//____________________________________________
uint8_t GUI_Display(uint8_t *bf,uint32_t w,uint32_t h)
{
if(bf==NULL) bf=rdr_decomp_buffer;
if(w==0) w=Rw;
if(h==0) h=Rh;
#ifdef  USE_XV
    if (_XvAvailable && xv_mode)
						GUI_XvDisplay(bf, w, h);
    else
#endif
	{
    	GUI_ConvertRGB(bf, screen_buffer, w,h);
			GUI_RGBDisplay(screen_buffer, w, h,drawingarea1);
  	}


    return 1;
}

// Swap Red and Blue component
// Usefull for bmp for example
//____________________________________________________
void swapRnB(uint8_t * ptr, uint32_t w)
{
    uint8_t r;
    while (w-- > 0)
      {
	  r = *ptr;
	  *ptr = *(ptr + 2);
	  *(ptr + 2) = r;
	  ptr += 3;
      }

}

/*
Packed
		Integer computation convert yuy2 -> plain RGB
		

   221=2097152
R = Y + 1.402V              2940207
G = Y - 0.344U - 0.714V     721420 1497366
B = Y + 1.772U              3716153
See
http://support.microsoft.com/default.aspx?scid=kb;EN-US;q294880
For format explanation
*/
#ifndef COLORSPACE_YV12
uint8_t slowYUYV2RGB(uint8_t * ptr_y,
		     uint8_t * ptr_u,
		     uint8_t * ptr_v, uint8_t * ptr2, uint32_t w)
{

    int32_t y0, u0, v0, y1;
    int32_t r, g, b;
    int32_t r1, g1, b1;
#define FAC  2097152
#define RFAC 2940207
#define GFAC1 721420
#define GFAC2 1497366
#define BFAC 3716153
/*  	Let's do 2^21 computation   */

    w >>= 1;
    while (w--)
      {
	  y0 = (*ptr_y++) * FAC;
	  u0 = (*ptr_y++ - 128);
	  y1 = (*ptr_y++) * FAC;
	  v0 = (*ptr_y++ - 128);

	  r1 = RFAC * v0;
	  g1 = -GFAC1 * u0 - GFAC2 * v0;
	  b1 = +BFAC * u0;
	  r = (y0 + r1) >> 21;
	  g = (y0 + g1) >> 21;
	  b = (y0 + b1) >> 21;

#define CLIP(x) if(x<0) x=0;if(x>255) x=255;
	  CLIP(r);
	  CLIP(g);
	  CLIP(b);
	  *ptr2++ = r;
	  *ptr2++ = g;
	  *ptr2++ = b;

	  //--------------------
	  r = (y1 + r1) >> 21;
	  g = (y1 + g1) >> 21;
	  b = (y1 + b1) >> 21;
	  CLIP(r);
	  CLIP(g);
	  CLIP(b);
	  *ptr2++ = r;
	  *ptr2++ = g;
	  *ptr2++ = b;
      }
    return 1;
}

//____________________________________________________________
// YUYV Version
//____________________________________________________________
void yuv2rgb(uint8_t * ptr, uint8_t * ptr2, uint32_t w, uint32_t h)
{
    uint32_t i, l;
    uint8_t *y, *u, *v, *e;

    l = w;			// line width in byte
    y = ptr;
    u = ptr;
    v = ptr;
    e = ptr2;

    for (i = h; i > 0; i--)
      {
	  slowYUYV2RGB(y, u, v, e, w);
	  y += w * 2;
	  e += w * 3;
	  u += w * 2;
	  v += w * 2;
      }

}
#endif


//
