/***************************************************************************
                          oplug_avi.cpp  -  description
                             -------------------

		This set of function is here to provide a simple api to the gui
		It will facilitate the use of other function such as audio processing
		etc...

    begin                : Mon Feb 11 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <assert.h>
#include <math.h>

#include "avifmt.h"
#include "avifmt2.h"
#include "avio.hxx"
#include "fourcc.h"
#include "riffparser.h"
#include "subchunk.h"
#include "avilist.h"
#include "op_aviwrite.hxx"
//------------
typedef struct
{
  uint32_t fcc, flags, offset, len;
}
IdxEntry;

//
//
FILE *out = NULL;
MainAVIHeader mainheader;
AviList *LAll = NULL, *LMovie = NULL;
AVIStreamHeader videostream;
AVIStreamHeader astream;
AVIStreamHeader astream2;
uint32_t curindex;
IdxEntry *myindex = NULL;
uint32_t asize;
uint32_t asize2;

uint32_t vframe;

uint8_t
aviWrite::updateHeader (MainAVIHeader * mainheader,
			AVIStreamHeader * videostream,
			AVIStreamHeader * astream)
{
  UNUSED_ARG(astream);

  fseek (out, 32, SEEK_SET);
// Update main header
  fwrite (mainheader, sizeof (MainAVIHeader), 1, out);
// now update video stream header
  fseek (out, 0x6c, SEEK_SET);

  fwrite (videostream, sizeof (AVIStreamHeader), 1, out);

  // should do audio too, but i's relatively harmless...
  // Yes, indeed it helps for VBR audio :)

  return 1;
}

//________________________________________________
//   Beginning of the write process
//   We fill-in the headers
//_______________________________________________
uint8_t
aviWrite::setHeader (	FILE * out,
		     	AVDMGenericAudioStream * audiostream,
		     	AVIStreamHeader * videostream,
		     	MainAVIHeader * header, 
			uint8_t * bih,
			uint32_t  bihLen,						
          		AVDMGenericAudioStream * audiostream2 )
{
  AviList *LMain;
  WAVHeader *wav = NULL;



  assert (out);
  assert (LAll == NULL);

  fseek (out, 0, SEEK_SET);	// rewind

  LAll = new AviList ("RIFF", out);
  LAll->Begin ("AVI ");
  // Header chunk
  LMain = new AviList ("LIST", out);
  LMain->Begin ("hdrl");
  LMain->Write32 ("avih");
  LMain->Write32 (sizeof (MainAVIHeader));
  LMain->Write ((uint8_t *) header, sizeof (MainAVIHeader));
/*
		         stream 1 header
*/
  setStreamInfo (out,
		 (uint8_t *) videostream,
		  bih,bihLen, 0x1000);

/*
		         stream 2 header
*/

  if (audiostream)
    {

      wav = audiostream->getInfo ();
//
      assert (wav);

      memset (&astream, 0, sizeof (AVIStreamHeader));
      astream.fccType = fourCC::get ((uint8_t *) "auds");
      astream.dwInitialFrames = 0;
     
      astream.dwStart = 0;
      astream.dwRate = wav->byterate;
      astream.dwSampleSize = 1;
      astream.dwQuality = 0xffffffff;
      astream.dwSuggestedBufferSize = 8000;
      astream.dwLength = audiostream->getLength ();

     
      
			switch(wav->encoding)
			{
				case WAV_MP3:							
				  WAVHeaderVBR	    vbr;

				  // copy beginning of header
				  memset(&vbr,0,sizeof(vbr));
				  memcpy (&vbr, wav, sizeof (WAVHeader));
				  // then update VBR fields
				  vbr.cbsize = 12;
				  vbr.wId = 1;
				  vbr.fdwflags = 2;				  
			    vbr.nframesperblock = 1;
				  vbr.ncodecdelay = 0;
				  vbr.bitspersample = 0;
				  vbr.nblocksize=0x180; //383; // ??
				  
				  astream.dwScale = 1;
			  	astream.dwInitialFrames = 1;
		    
	      	if (vbr.blockalign ==1152)	// VBR audio
					{			// We do like nandub do
				  	//assert (audiostream->asTimeTrack ());
				  	vbr.blockalign = 1152;	// just a try
				     vbr.bitspersample = 16;
				  
				    astream.dwRate = wav->frequency;	//wav->byterate;
						astream.dwScale = wav->blockalign;
				  
					  astream.dwLength=videostream->dwLength;
				   
		  			astream.dwSampleSize = 0;
				  	printf ("\n VBR audio detected\n");
				  	//
				  	// use extended headers
				  	//		
				  	//
				  	double	    nb;
				  	nb = audiostream->getLength ();
				  //	nb /= audiostream->nbFrameSlice ();;
				  	nb/= videostream->dwLength;
				  	// avg value of a block (i.e. a mpeg frame)
				  	vbr.nblocksize = (uint32_t) floor (nb);			
				   }	
				   else vbr.blockalign=1;
				  setStreamInfo (out,
						(uint8_t *) & astream,
					 	(uint8_t *) & vbr, 30 /*sizeof (WAVHeaderVBR)*/, 0x1000);
					  break;
	
					 
		case WAV_WMA:
				astream.dwScale = wav->blockalign;
				astream.dwSampleSize =	wav->blockalign;
				astream.dwInitialFrames =1;				
				astream.dwSuggestedBufferSize=10*wav->blockalign;				
				
				uint8_t wmaheader[28];
				memset(wmaheader,0,28);
				memcpy(wmaheader,wav,sizeof(WAVHeader));
				wmaheader[16]=0x0a;
				wmaheader[19]=0x08;
				wmaheader[22]=0x01;
				wmaheader[24]=0x74;
				wmaheader[25]=01;
						  setStreamInfo (out,
			 (uint8_t *) & astream,
			 (uint8_t *) wmaheader, 28, 0x1000);
				break;
	default:
				astream.dwScale = 1;  
				wav->blockalign=1;	
	   setStreamInfo (out,
			 (uint8_t *) & astream,
			 (uint8_t *) wav, sizeof (WAVHeader), 0x1000);
				break;
    }
    }
/* other audio stream */
  if (audiostream2)
    {
		printf("\n Second audio stream info ...\n");
      wav = audiostream2->getInfo ();
//
      assert (wav);

      memset (&astream, 0, sizeof (AVIStreamHeader));
      astream.fccType = fourCC::get ((uint8_t *) "auds");
      astream.dwInitialFrames = 0;
      astream.dwScale = 1;
      astream.dwStart = 0;
      astream.dwRate = wav->byterate;
      astream.dwSampleSize = 1;
      astream.dwQuality = 0xffffffff;
      astream.dwSuggestedBufferSize = 8000;
      astream.dwLength = audiostream2->getLength ();

	  setStreamInfo (out,
			 (uint8_t *) & astream,
			 (uint8_t *) wav, sizeof (WAVHeader), 0x1000);
    }
  printf ("\n End of header...\n\n");
  LMain->End ();
  delete
    LMain;
  return 1;
}

//_______________________________________________________
//
//   Begin to save, built header and prepare structure
//   The nb frames is indicative but the real value
//   must be smaller than this parameter
//
//_______________________________________________________
uint8_t
aviWrite::saveBegin (char *name,
		     AVIStreamHeader * invideostream,
		     uint8_t * bih,
		     uint32_t  bihLen,
		     AVDMGenericAudioStream * inaudiostream,
		     MainAVIHeader * inmainheader, uint32_t nb_frame,
		     AVDMGenericAudioStream * inaudiostream2)
{

	asize=asize2=0;

//  Sanity Check
  assert (out == NULL);
  if (!(out = fopen (name, "wb")))
  {
		printf("Problem writing : %s\n",name);
    return 0;
    }
  curindex = 0;
  vframe = asize = 0;
// update avi header according to the information WE want
//
  memcpy (&mainheader, inmainheader, sizeof (MainAVIHeader));
  mainheader.dwFlags = AVIF_HASINDEX + AVIF_ISINTERLEAVED;
  // update main header codec with video codev
  if (inaudiostream)
    mainheader.dwStreams = 2;
  else
    mainheader.dwStreams = 1;

	if(inaudiostream2)
	{
	 printf("\n Dual audio stream...\n");
     mainheader.dwStreams ++;
	}

  mainheader.dwTotalFrames = nb_frame;
//  Idem for video stream
//
  memcpy (&videostream, invideostream, sizeof (AVIStreamHeader));
  videostream.dwLength = nb_frame;
#warning Unsure about this patch ...
  //videostream.fccHandler=fourCC::get( (uint8_t *)"DIVX");

  //___________________
  // Prepare header
  //___________________
  setHeader (out, inaudiostream, &videostream, &mainheader, bih,bihLen,inaudiostream2);
#warning JUST TO COMPILE IT
  assert (!LMovie);
  LMovie = new AviList ("LIST", out);
  LMovie->Begin ("movi");
  curindex = 0;
  // the *2 is for audio and video
  // the *3 if for security sake
  myindex = (IdxEntry *) malloc (sizeof (IdxEntry) * (nb_frame * 4));
  asize = 0;
  vframe = 0;
  return 1;

}

//_______________________________________________________
// Write video frames and update index accordingly
//_______________________________________________________
uint8_t
aviWrite::saveVideoFrame (uint32_t len, uint32_t flags, uint8_t * data)
{
  vframe++;
  return saveFrame (len, flags, data, (uint8_t *) "00dc");

}

uint8_t
aviWrite::saveAudioFrame (uint32_t len, uint8_t * data)
{
  asize += len;
  return saveFrame (len, (uint32_t) 0, data, (uint8_t *) "01wb");
}
uint8_t aviWrite::saveAudioFrameDual (uint32_t len, uint8_t * data)
{
  asize2 += len;
  return saveFrame (len, (uint32_t) 0, data, (uint8_t *) "02wb");
}



uint8_t
aviWrite::saveFrame (uint32_t len, uint32_t flags,
		     uint8_t * data, uint8_t * fcc)
{
  uint32_t
    offset;
  // offset of this chunk compared to the beginning
  offset = LMovie->Tell () - 8 - LMovie->TellBegin ();
  LMovie->WriteChunk (fcc, len, data);
  // Now store the index part

  myindex[curindex].fcc = fourCC::get (fcc);
  myindex[curindex].len = len;
  myindex[curindex].flags = flags;
  myindex[curindex].offset = offset;
  curindex++;
  return 1;
}

//_______________________________________________________
// End movie
//_______________________________________________________
uint8_t
aviWrite::setEnd (void)
{

  // First close the movie
  LMovie->End ();
  delete
    LMovie;
  LMovie = NULL;



  printf ("\n writing %lu index parts", curindex);
  printf ("\n received %lu video parts", vframe);

// Updating compared to what has been really written
//

  // Write index  
  LAll->Write32 ("idx1");
  LAll->Write32 (curindex * 16);

  for (uint32_t i = 0; i < curindex; i++)
    {
      LAll->Write32 (myindex[i].fcc);
      LAll->Write32 (myindex[i].flags);
      LAll->Write32 (myindex[i].offset);	// abs position
      LAll->Write32 (myindex[i].len);
    }
  // Close movie


  LAll->End ();
  delete
    LAll;
  LAll = NULL;
 printf ("\n Updating headers...\n");
  mainheader.dwTotalFrames = vframe;
  videostream.dwLength = vframe;
  astream.dwLength = asize;

// Update Header
  updateHeader (&mainheader, &videostream, &astream);


	printf("\n End of movie, \n video frames : %lu\n audio frames : %lu",vframe,asize);
  // need to update headers now
  // AUDIO SIZE ->TODO

  fclose (out);
  out = NULL;
  return 1;

}

//
//
//
uint8_t
aviWrite::setStreamInfo (FILE * fo,
			 uint8_t * stream,
			 uint8_t * info, uint32_t infolen, uint32_t maxxed)
{


  AviList *
    alist;
  uint8_t *
    junk;
  uint32_t
    junklen;

  alist = new AviList ("LIST", fo);


  // 12 LIST
  // 8 strf subchunk
  // 8 strl subchunk
  // 8 defaultoffset
  alist->Begin ("strl");

  // sub chunk 1
  alist->WriteChunk ((uint8_t *) "strh", sizeof (AVIStreamHeader),
		     (uint8_t *) stream);
  alist->WriteChunk ((uint8_t *) "strf", infolen, (uint8_t *) info);

  // FIXME!!!!!!!!!!!!!!!!!!!!!!!
#warning fixme badly
  junklen = maxxed - sizeof (AVIStreamHeader) - infolen;
  junk = (uint8_t *) malloc (junklen);
  bzero (junk, junklen);
  assert (junk);
  alist->WriteChunk ((uint8_t *) "JUNK", junklen, junk);
  free (junk);

  alist->End ();
  delete
    alist;
  return 1;


}
// return how much has been written
uint32_t	aviWrite::getPos( void )
{
uint32_t pos;
	 // we take size of file + index
	 // with 32 bytes per index entry
	 // 
	 assert(out);
	 pos=ftello(out);
	 return pos+curindex*4*4;	 	
}
// EOF
