#ifndef _preferences_h_
#define _preferences_h_

#include "ADM_library/default.h"

extern void saveEncoderConfig( void );
extern void loadEncoderConfig( void );
// <prefs_gen>
typedef enum {
	CODECS_MPEG2ENC_SVCD_MAXBITRATE,
	CODECS_MPEG2ENC_SVCD_QUANTISATION,
	CODECS_MPEG2ENC_SVCD_EXTRAPARAMS,
	CODECS_MPEG2ENC_DVD_MAXBITRATE,
	CODECS_MPEG2ENC_DVD_QUANTISATION,
	CODECS_MPEG2ENC_DVD_EXTRAPARAMS,
	TEST_STRING,
	TEST_INT,
	TEST_UINT,
	TEST_LONG,
	TEST_ULONG,
	TEST_FLOAT,
	CODECS_PREFERREDCODEC
} options;
// </prefs_gen>

class preferences {
	public:
		preferences();
		~preferences();
		int load();
		int save();
		int get(options option, unsigned int *val);
		int get(options option,          int *val);
		int get(options option, unsigned long *val);
		int get(options option,          long *val);
		int get(options option, float *val);
		int get(options option, const char **val);
		int get(options option, uint8_t *val);
		int get(options option, uint16_t *val);
		const char * get_str_min(options option);
		const char * get_str_max(options option);
		// handled by compiler: const uint8_t is full handled by any 
		//    method that can handle const unsigned int
		// int set(options option, const uint8_t val);
		// int set(options option, const uint16_t val);
		int set(options option, const unsigned int val);
		int set(options option, const          int val);
		int set(options option, const unsigned long val);
		int set(options option, const          long val);
		int set(options option, const          float val);
		int set(options option, const          char * val);
};

extern preferences *prefs;

#endif
